'From Squeak3.2gamma of 15 January 2002 [latest update: #4913] on 22 July 2002 at 3:50:11 am'!
Object subclass: #AbstractResolver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClientServer-Locator'!
Object subclass: #EventualMessage
	instanceVariableNames: 'message receiver resolver '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'References'!
AbstractResolver subclass: #LocalResolver
	instanceVariableNames: 'promise messageQueue secretary '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'References'!
Object subclass: #ReferenceContext
	instanceVariableNames: 'target redirector '
	classVariableNames: 'MyTracer '
	poolDictionaries: ''
	category: 'References'!

!ReferenceContext commentStamp: '<historical>' prior: 0!
"Eventual Sending References"

"Great first example, even if it is as easily done in Morphic"
	ReferenceContext blinkingExample.

"Example code"
[
	ReferenceContext traceOff.
	Object new eventualRef actionMap 
		whenResolved: [:ref | Transcript cr; show: 'last print this: ', ref printString].
	Transcript cr; show: 'first print this'.
]

"Other examples"
	ReferenceContext whenResolvedExample.
	ReferenceContext ifBrokenExample.
	ReferenceContext basicPromiseExample.
	ReferenceContext morphExample.
	ReferenceContext promiseSendingExample.

"For the details - Logging"
	ReferenceContext traceToTranscript.
	ReferenceContext traceOff.
	ReferenceContext traceToLog.

"Redirection VM?"
	RedirectionManager isEnabled.
	RedirectionManager enable.
	RedirectionManager disable.


"Debug utilities"
[
	Smalltalk garbageCollect.
	( {ReferenceContext. LocalResolver. QueuedFuture.} 
		inject: Set new
		into: [:set :class | set addAll: class allSubInstances. set]) size > 0 ifTrue: [self halt].
]

[
	({PromiseReferenceContext.} 
		inject: OrderedCollection new
		into: [:set :class | set addAll: class allSubInstances. set])
			do: [:e | e releaseActionMap].
]

[
	Morph allInstances do: [:e | e abandon].
]


!

ReferenceContext subclass: #BrokenContext
	instanceVariableNames: 'exception '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'References'!
ReferenceContext subclass: #FarContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'References'!
ReferenceContext subclass: #NearContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'References'!
ReferenceContext subclass: #PromiseContext
	instanceVariableNames: 'messageQueue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'References'!
PromiseContext subclass: #RemotePromiseContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'References'!
AbstractResolver subclass: #RemoteResolver
	instanceVariableNames: 'promise messageQueue secretary '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'References'!
Object subclass: #Tracer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tracer'!
Tracer subclass: #LogTracer
	instanceVariableNames: 'logStream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tracer'!
Tracer subclass: #NullTracer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tracer'!
Tracer subclass: #TranscriptTracer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tracer'!

!ProtoObject methodsFor: 'system primitives' stamp: 'rw 3/23/2002 19:09'!
ifBroken: anExceptionResolver

! !

!ProtoObject methodsFor: 'system primitives' stamp: 'rw 3/23/2002 19:08'!
whenResolved: aValueResolver

	aValueResolver value: self
! !

!ProtoObject methodsFor: 'system primitives' stamp: 'rw 3/23/2002 19:09'!
whenResolved: aValueResolver ifBroken: anExceptionResolver

	aValueResolver value: self
! !

!ProtoObject methodsFor: 'debugging' stamp: 'rww 7/15/2002 15:18'!
traceString: aString

	self class traceString: aString! !


!MessageRedirectorProxy methodsFor: 'as yet unclassified' stamp: 'rw 3/23/2002 19:34'!
ifBroken: aBlock

	self doesNotUnderstand: (Message selector: #ifBroken: arguments: (Array with: aBlock))! !

!MessageRedirectorProxy methodsFor: 'as yet unclassified' stamp: 'rw 3/23/2002 19:33'!
whenResolved: aBlock

	self doesNotUnderstand: (Message selector: #whenResolved: arguments: (Array with: aBlock))! !

!MessageRedirectorProxy methodsFor: 'as yet unclassified' stamp: 'rw 3/23/2002 19:33'!
whenResolved: aBlock ifBroken: anExceptionBlock

	self doesNotUnderstand: (Message selector: #whenResolved:ifBroken: arguments: (Array with: aBlock with: anExceptionBlock))! !


!Object methodsFor: 'async sending' stamp: 'rw 4/7/2002 15:21'!
eventualRef

	^ NearContext newOn: self
! !

!Object methodsFor: 'async sending' stamp: 'rw 5/4/2002 05:28'!
sendEventualMessage: msgSend

	msgSend receiver: self.
	self secretary sendMessage: msgSend.
! !


!AbstractResolver methodsFor: 'api' stamp: 'rw 3/16/2002 23:19'!
isDone
	"
		If not isDone(), both resolve() and smash() will work.
		If isDone(), neither resolve() nor smash() will work.  Once a Resolver
		is done, it is done forever.
	"

	self subclassResponsibility
! !

!AbstractResolver methodsFor: 'api' stamp: 'rw 3/16/2002 23:21'!
resolve: aTarget
	"
		Queues all accumulated and future messages for delivery to target,
		and, for example, a local promise becomes resolved into being
		E-equivalent to the target.  If isDone(), an exception is thrown
		instead.  A Resolver will be isDone() following a resolve().
	"

	self subclassResponsibility
! !

!AbstractResolver methodsFor: 'api' stamp: 'rw 3/16/2002 23:20'!
smash: anException
    "
		Breaks the promise, reporting 'problem' as the reason.  If not yet
		done, 'r smash(p)' is equivalent to
		'r resolve(Ref broken(p))'.  If isDone(), returns
		false rather than throwing an exception.  A Resolver will be
		isDone() following a smash().
	"

	self subclassResponsibility
! !


!EventualMessage methodsFor: 'as yet unclassified' stamp: 'rw 4/7/2002 17:19'!
message

	^message! !

!EventualMessage methodsFor: 'as yet unclassified' stamp: 'rw 4/7/2002 17:36'!
message: aMessage

	aMessage lookupClass: nil.
	message := aMessage! !

!EventualMessage methodsFor: 'as yet unclassified' stamp: 'rw 5/4/2002 05:12'!
receiver

	^ receiver! !

!EventualMessage methodsFor: 'as yet unclassified' stamp: 'rw 5/4/2002 05:12'!
receiver: aReceiver

	receiver := aReceiver! !

!EventualMessage methodsFor: 'as yet unclassified' stamp: 'rw 3/24/2002 21:16'!
resolver

	^resolver
! !

!EventualMessage methodsFor: 'as yet unclassified' stamp: 'rw 3/24/2002 21:16'!
resolver: aResolver

	resolver := aResolver
! !

!EventualMessage methodsFor: 'as yet unclassified' stamp: 'rw 4/7/2002 17:56'!
selector

	^self message selector! !

!EventualMessage methodsFor: 'as yet unclassified' stamp: 'rw 5/4/2002 05:13'!
value

	[self resolver resolve: (self message sentTo: self receiver)]
		on: Exception
		do: [:ex | self resolver smash: ex].
! !


!LocalResolver methodsFor: 'accessing' stamp: 'rw 4/7/2002 17:15'!
messageQueue

	^ messageQueue! !

!LocalResolver methodsFor: 'accessing' stamp: 'rw 4/7/2002 17:15'!
messageQueue: aQueue

	messageQueue := aQueue.
! !

!LocalResolver methodsFor: 'accessing' stamp: 'rw 3/16/2002 12:56'!
promise 

	^promise! !

!LocalResolver methodsFor: 'accessing' stamp: 'rw 3/16/2002 14:48'!
promise: aPromise

	promise := aPromise! !

!LocalResolver methodsFor: 'resolving' stamp: 'rw 3/23/2002 18:18'!
isDone

	^ self promise isNil
	! !

!LocalResolver methodsFor: 'resolving' stamp: 'rw 4/7/2002 19:12'!
resolve: value

	| resultContext |
	self traceString: '  SETTLED: resolving promise'.
	self promise isNil ifTrue: [self error: 'done'].
	resultContext := ReferenceContext toReferenceContext: value.
	self promise becomeContext: resultContext.
	[self messageQueue isEmpty]
		whileFalse: [resultContext redirectEventualMessage: self messageQueue next].
	self promise: nil.
	self messageQueue: nil.
	

! !

!LocalResolver methodsFor: 'resolving' stamp: 'rw 4/7/2002 15:22'!
smash: exception

	| ref |
	self promise isNil ifTrue: [^false].
	ref := BrokenContext new.
	ref exception: exception.
	self traceString: '  SMASH: broken promise: ', ref printString.
	^self resolve: ref.
! !

!LocalResolver methodsFor: 'tracing' stamp: 'rw 3/24/2002 18:14'!
traceString: aString

	ReferenceContext traceString: aString! !

!LocalResolver methodsFor: 'sending' stamp: 'rw 4/7/2002 19:26'!
future

	| future |
	future := super future.
	future when: #result: send: #resolve: to: self.
	future when: #exception: send: #smash: to: self.
	^future! !


!ProtoObject class methodsFor: 'tracing' stamp: 'rww 7/15/2002 15:20'!
traceOff

	self tracer: NullTracer new.
! !

!ProtoObject class methodsFor: 'tracing' stamp: 'rww 7/15/2002 15:18'!
traceString: aString

	self tracer traceString: aString
! !

!ProtoObject class methodsFor: 'tracing' stamp: 'rww 7/15/2002 15:20'!
traceToLog

	self tracer: (LogTracer new
		logStream: (FileStream fileNamed: 'esend.log');
		yourself)
! !

!ProtoObject class methodsFor: 'tracing' stamp: 'rww 7/15/2002 15:21'!
traceToTranscript

	self tracer: TranscriptTracer new.
! !

!ProtoObject class methodsFor: 'tracing' stamp: 'rww 7/15/2002 15:20'!
tracer

	Smalltalk at: #MyTracer ifAbsent: [Smalltalk at: #MyTracer put: TranscriptTracer new].
	^Smalltalk at: #MyTracer ! !

!ProtoObject class methodsFor: 'tracing' stamp: 'rww 7/15/2002 15:20'!
tracer: aTracer

	Smalltalk at: #MyTracer put: aTracer.
! !


!EventualMessage class methodsFor: 'as yet unclassified' stamp: 'rw 4/7/2002 17:20'!
message: aMessage resolver: aResolver

	^ self new
		message: aMessage;
		resolver: aResolver;
		yourself
! !


!ReferenceContext methodsFor: 'accessing' stamp: 'rw 3/16/2002 19:55'!
redirector

	^redirector! !

!ReferenceContext methodsFor: 'accessing' stamp: 'rw 3/24/2002 13:23'!
redirector: aRedirector

	redirector := aRedirector! !

!ReferenceContext methodsFor: 'accessing' stamp: 'rw 3/16/2002 19:55'!
target
	^target! !

!ReferenceContext methodsFor: 'accessing' stamp: 'rw 3/16/2002 19:55'!
target: aTarget
	target := aTarget! !

!ReferenceContext methodsFor: 'redirection' stamp: 'rw 5/4/2002 05:30'!
redirectEventualMessage: aMessage
 
	| receiver |
	receiver := (self isControlSelector: aMessage selector)
		ifTrue: [self]
		ifFalse: [target].
	receiver sendEventualMessage: aMessage.
! !

!ReferenceContext methodsFor: 'redirection' stamp: 'rw 5/4/2002 10:38'!
redirectMessage: aMessage

	| promiseAssociation msg |
	(self immediateCallSelectors includes: aMessage selector)
		ifTrue: [^ self perform: aMessage selector withArguments: aMessage arguments].
	promiseAssociation := self class promiseAssociationForSender: thisContext sender.
	msg := EventualMessage 	message: aMessage resolver: promiseAssociation value.
	self redirectEventualMessage: msg.
	^ promiseAssociation key
! !

!ReferenceContext methodsFor: 'resolving' stamp: 'rw 4/7/2002 17:54'!
becomeContext: aContext

	(Array with: self) elementsForwardIdentityTo: (Array with: aContext).
	aContext redirector: self redirector.! !

!ReferenceContext methodsFor: 'resolving' stamp: 'rw 3/16/2002 15:20'!
ifBroken: anExceptionResolver

! !

!ReferenceContext methodsFor: 'resolving' stamp: 'rw 3/24/2002 18:41'!
whenResolved: aValueResolver

	aValueResolver value: self redirector
! !

!ReferenceContext methodsFor: 'resolving' stamp: 'rw 3/16/2002 15:21'!
whenResolved: aValueResolver ifBroken: anExceptionResolver

	aValueResolver value: self redirector
! !

!ReferenceContext methodsFor: 'initialization' stamp: 'rw 3/16/2002 20:10'!
initialize

	redirector := RedirectionManager createRedirectorOnContext: self! !

!ReferenceContext methodsFor: 'tracing' stamp: 'rw 5/18/2002 06:30'!
inspect
Transcript cr; show: 'inspecting...'.

	^Inspector openOn: self redirector withEvalPane: true

! !

!ReferenceContext methodsFor: 'tracing' stamp: 'rw 3/24/2002 18:06'!
printOn: stream

	self target printOn: stream.
	stream nextPutAll: self refDescriptionString.
	^ stream! !

!ReferenceContext methodsFor: 'tracing' stamp: 'rw 3/19/2002 09:56'!
refDescriptionString

	^'(ref)'! !

!ReferenceContext methodsFor: 'tracing' stamp: 'rw 3/10/2002 18:46'!
traceString: aString

	self class traceString: aString! !

!ReferenceContext methodsFor: 'testing' stamp: 'rw 3/24/2002 21:39'!
eventualControlSelectors

	^ #(#whenResolved: #whenResolved:ifBroken: #ifBroken:)

! !

!ReferenceContext methodsFor: 'testing' stamp: 'rw 4/6/2002 12:35'!
immediateCallSelectors

	^ #(
		#size
		#isMemberOf:
		#class 
		#== 
		#basicEquivalence: 
		#instVarAt: 
		#isNil 
		#notNil 
		#ifNil: 
		#ifNotNil: 
		#isInMemory
		#printString 
		#inspect 
		#isText 
		#longPrintString 
		#printStringLimitedTo: 
		#printOn: 
		#isKindOf: 
		#defaultLabelForInspector 
		#secretary 
		#perform:withArguments:)

! !

!ReferenceContext methodsFor: 'testing' stamp: 'rw 4/7/2002 21:22'!
isControlSelector: aSelector

	^ self eventualControlSelectors includes: aSelector! !

!ReferenceContext methodsFor: 'testing' stamp: 'rw 4/7/2002 21:23'!
isImmediateCallSelector: aSelector

	^ self immediateCallSelectors includes: aSelector
! !


!BrokenContext methodsFor: 'as yet unclassified' stamp: 'rww 3/9/2002 12:00'!
exception

	^exception! !

!BrokenContext methodsFor: 'as yet unclassified' stamp: 'rww 3/9/2002 11:59'!
exception: anException

	exception := anException! !

!BrokenContext methodsFor: 'as yet unclassified' stamp: 'rw 5/4/2002 05:37'!
redirectEventualMessage: aMessage

	self traceString: 
		self refDescriptionString, ' sending eventual message: ', aMessage selector printString.
	(self eventualControlSelectors includes: aMessage selector)
		ifTrue: [self sendEventualMessage: aMessage].
	self exception signal
! !

!BrokenContext methodsFor: 'resolving' stamp: 'rw 3/24/2002 22:05'!
whenResolved: aValueResolver
! !

!BrokenContext methodsFor: 'resolving' stamp: 'rw 3/24/2002 22:05'!
whenResolved: aValueResolver ifBroken: anExceptionResolver

	anExceptionResolver value: self redirector
! !

!BrokenContext methodsFor: 'tracing' stamp: 'rw 3/24/2002 22:06'!
printOn: stream

	stream nextPutAll: self refDescriptionString.
	^ stream

! !

!BrokenContext methodsFor: 'tracing' stamp: 'rw 3/25/2002 00:29'!
refDescriptionString

	^'(broken ref<', self exception printString, ': ', self exception printString, '>)'! !

!BrokenContext methodsFor: '-- all --' stamp: 'rw 3/25/2002 00:40'!
ifBroken: anExceptionResolver

	anExceptionResolver value: self redirector.

"	[self exception signal]
		on: self exception class
		do: [:ex | anExceptionResolver value: ex].
"! !


!FarContext methodsFor: 'as yet unclassified' stamp: 'rww 7/16/2002 16:46'!
redirectEventualMessage: aMessage
 
	(self isControlSelector: aMessage selector)
		ifTrue: [self sendEventualMessage: aMessage.]
		ifFalse: [target].
! !

!FarContext methodsFor: 'as yet unclassified' stamp: 'rww 7/16/2002 04:18'!
refDescriptionString

	^'(far ref)'! !


!NearContext methodsFor: 'as yet unclassified' stamp: 'rw 3/19/2002 09:55'!
refDescriptionString

	^'(near ref)'! !


!PromiseContext methodsFor: 'resolving' stamp: 'rw 4/6/2002 12:34'!
isInMemory
	"All normal objects are."
	^ false! !

!PromiseContext methodsFor: 'resolving' stamp: 'rw 5/4/2002 05:34'!
redirectEventualMessage: aMessage
 
	messageQueue nextPut: aMessage.
! !

!PromiseContext methodsFor: 'resolving' stamp: 'rw 4/7/2002 17:13'!
resolverClass

	^ LocalResolver ! !

!PromiseContext methodsFor: 'resolving' stamp: 'rww 7/16/2002 16:53'!
resolverForSender: aSender

	^ self resolverClass new
		promise: self;
		messageQueue: messageQueue;
		yourself.
! !

!PromiseContext methodsFor: 'tracing' stamp: 'rw 3/24/2002 18:11'!
printOn: stream

	stream nextPutAll: self refDescriptionString.
	^ stream

! !

!PromiseContext methodsFor: 'tracing' stamp: 'rw 3/19/2002 09:55'!
refDescriptionString

	^'(promise)'! !

!PromiseContext methodsFor: 'initialization' stamp: 'rw 4/7/2002 17:14'!
initialize

	super initialize.
	messageQueue := SharedQueue new.
! !


!ReferenceContext class methodsFor: 'tracing' stamp: 'rw 3/10/2002 18:53'!
traceOff

	self tracer: NullTracer new.
! !

!ReferenceContext class methodsFor: 'tracing' stamp: 'rw 3/10/2002 18:44'!
traceString: aString

	self tracer traceString: aString
! !

!ReferenceContext class methodsFor: 'tracing' stamp: 'rw 3/24/2002 18:29'!
traceToLog

	self tracer: (LogTracer new
		logStream: (FileStream fileNamed: 'esend.log');
		yourself)
! !

!ReferenceContext class methodsFor: 'tracing' stamp: 'rw 3/10/2002 18:53'!
traceToTranscript

	self tracer: TranscriptTracer new.
! !

!ReferenceContext class methodsFor: 'tracing' stamp: 'rw 3/10/2002 18:42'!
tracer

	MyTracer isNil ifTrue: [MyTracer := TranscriptTracer new].
	^MyTracer! !

!ReferenceContext class methodsFor: 'tracing' stamp: 'rw 3/10/2002 18:43'!
tracer: aTracer

	MyTracer := aTracer! !

!ReferenceContext class methodsFor: 'instance creation' stamp: 'rw 3/16/2002 20:11'!
new

	^ super new initialize; yourself! !

!ReferenceContext class methodsFor: 'instance creation' stamp: 'rw 3/23/2002 12:03'!
newOn: anObject

	^ self new
		target: anObject;
		redirector! !

!ReferenceContext class methodsFor: 'instance creation' stamp: 'rw 4/7/2002 15:21'!
toReferenceContext: object

	| context |
	(object notNil and: [object isKindOf: ReferenceContext])
		ifTrue: [^ object].
	context := NearContext new.
	context target: object.
	^ context
! !

!ReferenceContext class methodsFor: 'promises' stamp: 'rw 3/24/2002 22:01'!
promiseAssociation
	"self promiseAssociation"

	^ self promiseAssociationForSender: thisContext sender.
! !

!ReferenceContext class methodsFor: 'promises' stamp: 'rw 4/7/2002 17:12'!
promiseAssociationForSender: aSender
	"self promiseAssociationForSender: thisContext sender"

	| context resolver |
	context := self promiseContextClass new.
	resolver := context resolverForSender: aSender.
	self traceString: 'new promise created'.
	^ Association key: context redirector value: resolver
! !

!ReferenceContext class methodsFor: 'promises' stamp: 'rw 4/7/2002 15:21'!
promiseContextClass

	^ PromiseContext ! !

!ReferenceContext class methodsFor: 'promises' stamp: 'rw 3/23/2002 12:06'!
resolverClass

	^ LocalResolver ! !

!ReferenceContext class methodsFor: 'testing' stamp: 'rw 3/25/2002 02:42'!
basicPromiseExample

	| pair |
	ReferenceContext traceToTranscript.
	pair := ReferenceContext promiseAssociation.
	pair key actionMap.
	pair value resolve: Object! !

!ReferenceContext class methodsFor: 'testing' stamp: 'rw 5/3/2002 18:05'!
blinkingExample

	ReferenceContext traceOff.
	20 timesRepeat: [World alarmScheduler
		addAlarm: #value 
		withArguments: #() 
		for:  
			[(Morph eventualRef new
				color: Color random;
				position: (World extent x atRandom @ World extent y atRandom);
				openInWorld) 
					whenResolved: [:morph | morph addAlarm: #abandon after: 1000 atRandom]]
		at: Time millisecondClockValue + (10 atRandom * 1000)] ! !

!ReferenceContext class methodsFor: 'testing' stamp: 'rw 3/25/2002 02:49'!
ifBrokenExample

	ReferenceContext traceOff.
	Object new eventualRef foobar 
		ifBroken: [:ex | Transcript cr; show: 'smashed from:   ', ex printString].
	Transcript cr; show: 'first print this'.
! !

!ReferenceContext class methodsFor: 'testing' stamp: 'rw 3/25/2002 02:43'!
morphExample

	| morphClassRef morphPromise |
	morphClassRef := Morph eventualRef.
	morphPromise := morphClassRef new openInWorld.
	morphPromise whenResolved: [:ref | Transcript cr; show: 'next print this ', ref printString. (Delay forMilliseconds: 100) wait].
	morphPromise abandon whenResolved: [:anotherRef | Transcript cr; show: 'last print this ', anotherRef printString].
	Transcript cr; show: 'first print this'.
! !

!ReferenceContext class methodsFor: 'testing' stamp: 'rw 3/25/2002 02:43'!
promiseSendingExample

	| smalltalkRef morphPromise  firstMorphPromise secondMorphPromise helpPromise |
	smalltalkRef := Smalltalk eventualRef.
	morphPromise := smalltalkRef at: #Morph.
	firstMorphPromise := morphPromise new openInWorld.
	helpPromise := firstMorphPromise help.
	helpPromise 
		whenResolved: [:promise | Transcript cr; show: 'print this when the help promise resolves: ', promise printString]
		ifBroken: [:brokenRef | Transcript cr; show: 'the help promise was smashed from:   ', brokenRef printString].
	secondMorphPromise := morphPromise new openInHand.
	firstMorphPromise 
		whenResolved: [:promise | Transcript cr; show: 'print this when the first morph promise resolves: ', promise printString]
		ifBroken: [:brokenRef | Transcript cr; show: 'the first morph promise was smashed from:   ', brokenRef printString].
	secondMorphPromise 
		whenResolved: [:promise | Transcript cr; show: 'print this when the second morph promise resolves: ', promise printString]
		ifBroken: [:brokenRef | Transcript cr; show: 'the first morph promise was smashed from:   ', brokenRef printString].
	firstMorphPromise abandon.
	secondMorphPromise abandon.
	Transcript cr; show: 'first print this'.
	(Delay forMilliseconds: 100) wait.
	Transcript cr; show: 'then print this'; cr.! !

!ReferenceContext class methodsFor: 'testing' stamp: 'rw 3/25/2002 02:49'!
whenResolvedExample

	ReferenceContext traceOff.
	Object new eventualRef actionMap 
		whenResolved: [:ref | Transcript cr; show: 'last print this: ', ref printString].
	Transcript cr; show: 'first print this'.
! !


!FarContext class methodsFor: 'promises' stamp: 'rww 7/16/2002 04:24'!
promiseContextClass

	^ RemotePromiseContext ! !


!RemotePromiseContext methodsFor: 'resolving' stamp: 'rww 7/16/2002 16:54'!
redirectEventualMessage: aMessage
 
	messageQueue nextPut: aMessage.
! !

!RemotePromiseContext methodsFor: 'resolving' stamp: 'rww 7/16/2002 04:25'!
resolverClass

	^ RemoteResolver ! !


!Tracer methodsFor: 'tracing' stamp: 'rw 3/10/2002 15:46'!
traceString: aString

	self subclassResponsibility! !


!LogTracer methodsFor: 'as yet unclassified' stamp: 'rw 3/24/2002 18:30'!
close

	self logStream notNil ifTrue: [self logStream close.  self logStream: nil].! !

!LogTracer methodsFor: 'as yet unclassified' stamp: 'rw 3/24/2002 18:25'!
logStream

	^logStream! !

!LogTracer methodsFor: 'as yet unclassified' stamp: 'rw 3/24/2002 18:26'!
logStream: aStream

	logStream := aStream! !

!LogTracer methodsFor: 'as yet unclassified' stamp: 'rw 3/24/2002 18:26'!
traceString: aString

	self logStream cr; nextPutAll: aString; flush.
! !


!NullTracer methodsFor: 'tracing' stamp: 'rw 3/10/2002 15:47'!
traceString: aString
! !


!TranscriptTracer methodsFor: 'tracing' stamp: 'rw 3/10/2002 16:34'!
traceString: aString

	Transcript cr; show: aString.
! !

LocalResolver removeSelector: #secretary!
LocalResolver removeSelector: #secretary:!
