'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 14 July 2002 at 2:16:39 pm'!
TestRunner subclass: #HierarchyTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UI'!

!HierarchyTestRunner commentStamp: '<historical>' prior: 0!
A hierarchical user interface to run all the test cases that exist in this image within the SUnit framework by Kent Beck and Erich Gamma (SUnit release 3.0).  See subclasses of TestCase for some sample tests.  See also the SUnit Homepage.

	"HierarchyTestRunner open"
	"HierarchyTestRunner runTests"
!
]style[(92 1 1 3 13 33 80 14 5 24 4 28 2)f1,f1cgreen;b,f1cred;b,f1bcblack;,f1,f1cblack;,f1,f1Rhttp://wiki.cs.uiuc.edu/CampSmalltalk/SUnit+Camp+Smalltalk;,f1,f1dHierarchyTestRunner open;;,f1,f1dHierarchyTestRunner runTests;;,f1!

ScrollPane subclass: #SimpleHierarchicalListMorph
	instanceVariableNames: 'selectedMorph getListSelector keystrokeActionSelector autoDeselect expandedForm notExpandedForm columns sortingSelector getSelectionSelector setSelectionSelector potentialDropMorph doubleClickSelector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Explorer'!
ListItemWrapper subclass: #TestSuiteWrapper
	instanceVariableNames: 'balloonText '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UI'!

!Behavior methodsFor: 'user interface' stamp: 'rww 1/12/2002 22:12'!
browseHierarchy

	"Create and schedule a new class hierarchy browser on the requested class/selector."
	| newBrowser |
	(newBrowser _ Browser new) setClass: self selector: nil.
	newBrowser spawnHierarchy.
! !


!HierarchyTestRunner methodsFor: 'interface opening' stamp: 'rww 1/12/2002 22:12'!
browseSelection

	testSuite browseHierarchy.! !

!HierarchyTestRunner methodsFor: 'interface opening' stamp: 'rww 1/14/2002 01:07'!
expandList

	testsList selectionIndex: 1.
	testsList selectedMorph toggleExpandedState.
	testsList adjustSubmorphPositions.
! !

!HierarchyTestRunner methodsFor: 'interface opening' stamp: 'rww 1/14/2002 01:01'!
initialTestList

	| testList |
"	testList _ (TestCase subclasses sortBy: [:a :b | a name < b name]) 
		collect: [ :each | TestSuiteWrapper with: each model: self].
	testList isEmpty ifTrue:[
		testList _ Array with: (TestSuiteWrapper 
			with: TestCase
			model: self)]."

	testList _ Array with: (TestSuiteWrapper 
		with: TestCase
		model: self).
	^testList! !

!HierarchyTestRunner methodsFor: 'interface opening' stamp: 'rww 1/14/2002 01:05'!
openAsMorph
	"TestRunner new openAsMorph"
	"=== build the parts ... ==="
	| topWindow runButton errorsList failuresList runOneButton refreshButton |
	Smalltalk isMorphic
		ifFalse: [^ self open].
	(topWindow _ SystemWindow labelled: self windowLabel) model: self.
	runButton _ PluggableButtonMorph
				on: self
				getState: #runButtonState
				action: #runTests
				label: #runButtonLabel.
	runButton color: self runButtonColor.
	runButton onColor: self runButtonColor offColor: self runButtonColor.
	runOneButton _ PluggableButtonMorph
				on: self
				getState: #runButtonState
				action: #runOneTest
				label: #runOneButtonLabel.
	runOneButton color: self runButtonColor.
	runOneButton onColor: self runButtonColor offColor: self runButtonColor.
	refreshButton _ PluggableButtonMorph
				on: self
				getState: #refreshButtonState
				action: #refreshTests
				label: #refreshButtonLabel.
	refreshButton color: self runButtonColor.
	refreshButton onColor: self runButtonColor offColor: self runButtonColor.
	passFailText _ PluggableTextMorph
				on: self
				text: #passFail
				accept: nil.
	passFailText hideScrollBarIndefinitely.
	detailsText _ PluggableTextMorph
				on: self
				text: #details
				accept: nil.
	detailsText hideScrollBarIndefinitely.
	testsList _ SimpleHierarchicalListMorph 
		on: self
		list: #initialTestList
		selected: #selectedSuite
		changeSelected: #selectedSuite:
		menu: nil
		keystroke: nil.
	testsList autoDeselect: false.
	testsList doubleClickSelector: #browseSelection.
	failuresList _ PluggableListMorph
				on: self
				list: #failures
				selected: #selectedFailureTest
				changeSelected: #debugFailureTest:.
	errorsList _ PluggableListMorph
				on: self
				list: #errors
				selected: #selectedErrorTest
				changeSelected: #debugErrorTest:.
	"=== assemble the whole ... ==="
	topWindow
		addMorph: refreshButton
		frame: (0.0 @ 0.0 extent: 0.2 @ 0.4).
	topWindow
		addMorph: testsList
		frame: (0.2 @ 0.0 extent: 0.6 @ 0.4).
	topWindow
		addMorph: runOneButton
		frame: (0.8 @ 0.0 extent: 0.2 @ 0.2).
	topWindow
		addMorph: runButton
		frame: (0.8 @ 0.2 extent: 0.2 @ 0.2).
	topWindow
		addMorph: passFailText
		frame: (0.0 @ 0.4 extent: 1.0 @ 0.1).
	topWindow
		addMorph: detailsText
		frame: (0.0 @ 0.5 extent: 1.0 @ 0.1).
	topWindow
		addMorph: failuresList
		frame: (0.0 @ 0.6 extent: 1.0 @ 0.2).
	topWindow
		addMorph: errorsList
		frame: (0.0 @ 0.8 extent: 1.0 @ 0.2).
	"=== open it ... ==="
	topWindow openInWorldExtent: 400 @ 600.
	self refreshWindow.
	self expandList.
	^ topWindow! !

!HierarchyTestRunner methodsFor: 'processing' stamp: 'rww 1/12/2002 22:36'!
runOneTest
	| suite |
	Cursor execute showWhile:
		[testSuite ifNil: 
			[self runWindow.
			^ self displayPassFail: 'No Test Suite Selected'].
		suite := (testSuite inheritsFrom: TestCase)
			ifTrue: [testSuite suite]
			ifFalse: [TestViaMethodCall buildSuite: testSuite name].

		self runWindow.
		result _ suite run.
		self updateWindow: result]
! !

!HierarchyTestRunner methodsFor: 'processing' stamp: 'rww 1/12/2002 22:36'!
selectedSuite: aWrapper

	testSuite := aWrapper withoutListWrapper.
	selectedSuite  := aWrapper.
	selectedFailureTest _ 0.
	selectedErrorTest _ 0.
	self changed: #selectedFailureTest.             "added rew"
	self changed: #selectedErrorTest.               "added rew" 
	self changed: #selectedSuite.! !

!HierarchyTestRunner methodsFor: 'constants' stamp: 'rww 1/12/2002 23:02'!
windowLabel

        ^'Squeak Hierarchy Test Runner'! !


!SimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'rww 1/12/2002 22:03'!
doubleClickSelector: aSymbol
	doubleClickSelector _ aSymbol! !

!SimpleHierarchicalListMorph methodsFor: 'events' stamp: 'rww 1/12/2002 22:04'!
doubleClick: event
	| aMorph |
	doubleClickSelector isNil ifTrue: [^super doubleClick: event].
	aMorph _ self itemFromPoint: event position.
	aMorph ifNil:[^super doubleClick: event].
	selectedMorph ifNil: [self setSelectedMorph: aMorph].
	^ self model perform: doubleClickSelector! !

!SimpleHierarchicalListMorph methodsFor: 'events' stamp: 'rww 1/12/2002 22:04'!
mouseDown: evt
	| aMorph selectors |
	aMorph _ self itemFromPoint: evt position.
	(aMorph notNil and:[aMorph inToggleArea: (aMorph point: evt position from: self)])
		ifTrue:[^self toggleExpandedState: aMorph event: evt]. 
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	aMorph ifNil:[^super mouseDown: evt].
	aMorph highlightForMouseDown.
	selectors _ Array 
		with: #click:
		with: (doubleClickSelector ifNotNil:[#doubleClick:])
		with: nil
		with: (self dragEnabled ifTrue:[#startDrag:] ifFalse:[nil]).
	evt hand waitForClicksOrDrag: self event: evt selectors: selectors threshold: 10 "pixels".! !


!TestRunner class methodsFor: 'instance creation' stamp: 'rww 1/20/2002 01:15'!
open
	"TestRunner open" 
	^self new openAsMorph; yourself
! !


!HierarchyTestRunner class methodsFor: 'instance creation' stamp: 'rww 1/12/2002 22:52'!
runTests
	"HierarchyTestRunner runTests"
	self open runTests.! !

!HierarchyTestRunner class methodsFor: 'instance creation' stamp: 'rww 1/12/2002 23:03'!
testRunnerUsage
	"Please see the HierarchyTestRunner class comment for some documentation."

	self error: 'comment only'.!
]style[(15 18 19 69)f1b,f1,f1LHierarchyTestRunner Comment;,f1! !

!HierarchyTestRunner class methodsFor: 'instance creation' stamp: 'rww 1/20/2002 01:15'!
xopen
	"HierarchyTestRunner open"
	^self new openAsMorph; yourself
! !


!TestSuite methodsFor: 'Running' stamp: 'rw 12/25/2001 01:26'!
debug
	self areAllResourcesAvailable ifFalse: [^TestResult signalErrorWith: 'Resource could not be initialized'].
	[self runCase] sunitEnsure: [self resources do: [:each | each reset]].
! !

!TestSuite methodsFor: 'Running' stamp: 'rw 12/25/2001 01:26'!
runCase

	self tests do: 
		[:each | 
		self sunitChanged: each.
		each runCase]
! !


!TestSuiteWrapper methodsFor: 'accessing' stamp: 'rww 1/12/2002 20:27'!
balloonText

	^balloonText! !

!TestSuiteWrapper methodsFor: 'accessing' stamp: 'rww 1/12/2002 20:27'!
balloonText: aStringOrNil

	balloonText _ aStringOrNil! !

!TestSuiteWrapper methodsFor: 'accessing' stamp: 'rww 1/14/2002 01:02'!
contents

	| wrappers |
	((item = TestCase) or: [item inheritsFrom: TestCase])
		ifTrue: 
			[wrappers := (item subclasses sortBy: [ :a :b | a name caseInsensitiveLessOrEqual: b name]) 
				collect: [ :n | TestSuiteWrapper with: n model: self]]
		ifFalse: [wrappers := SortedCollection new].
	(item == TestViaMethodCall) ifTrue: 
		[((Smalltalk allImplementorsOf: #exampleFor:) 
			sortBy: [ :a :b | a classSymbol caseInsensitiveLessOrEqual: b classSymbol]) 
				do: [:mr | mr classIsMeta 
					ifTrue: [wrappers add: (TestSuiteWrapper with: mr actualClass model: self)]]].
	^ wrappers
! !

!TestSuiteWrapper methodsFor: 'accessing' stamp: 'rww 1/12/2002 20:31'!
settingSelector
	^#selectedSuite:! !


!TheWorldMenu methodsFor: 'construction' stamp: 'rw 4/13/2002 16:00'!
openMenu
        "Build the open window menu for the world."

        | menu |
        menu _ self menu: 'open...'.
        self fillIn: menu from: {

                {'browser (b)' . { Browser . #openBrowser} }.
                {'package browser' . { PackagePaneBrowser . #openBrowser} }.
                {'workspace (k)' . {self . #openWorkspace} }.
                {'file list' . {self . #openFileList} }.
                {'file...' . { FileList . #openFileDirectly} }.
                {'transcript (t)' . {self . #openTranscript} }.
                {'test runner' . {HierarchyTestRunner . #open} }.
               {'vmmaker' . {VMMakerTool . #openInWorld} }.
                "{'inner world' . { WorldWindow . #test1} }."
                nil.
                {'method finder' . { self . #openSelectorBrowser} }.
                {'message names (W)' . { self . #openMessageNames} }.
			 nil.
			{'simple change sorter' . {self . #openChangeSorter1} }.
			{'dual change sorter' . {self . #openChangeSorter2} }.
			nil.
			{'email reader' . {self . #openEmail} }.
			{'web browser' . { Scamper . #openAsMorph} }.
			{'original IRC chat'. {self. #openIRC}}. 
			{'enhanced IRC chat'. {self. #openEnhancedIRC}}.
                nil.
        }.
        self mvcProjectsAllowed ifTrue:
                [self fillIn: menu from: { {'mvc project' . {self. #openMVCProject} } }].

        ^ self fillIn: menu from: { 
                {'morphic project' . {self. #openMorphicProject} }.
        }.
! !

