'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 14 July 2002 at 2:21:11 pm'!
TestCase subclass: #ExecuteCompiledMethodTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Redirector Tests'!
Object subclass: #MessageRedirector
	instanceVariableNames: 'handle '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Redirector'!
ProtoObject subclass: #MessageRedirectorProxy
	instanceVariableNames: 'context '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Redirector'!
Object subclass: #ObjectMemory
	instanceVariableNames: 'memory youngStart endOfMemory memoryLimit nilObj falseObj trueObj specialObjectsOop rootTable rootTableCount child field parentField freeBlock lastHash allocationCount lowSpaceThreshold signalLowSpace compStart compEnd fwdTableNext fwdTableLast remapBuffer remapBufferCount allocationsBetweenGCs tenuringThreshold statFullGCs statFullGCMSecs statIncrGCs statIncrGCMSecs statTenures statRootTableOverflows freeContexts freeLargeContexts interruptCheckCounter displayBits totalObjectCount shrinkThreshold growHeadroom '
	classVariableNames: 'AllButHashBits AllButMarkBit AllButMarkBitAndTypeMask AllButRootBit AllButTypeMask BaseHeaderSize BlockContextProto CharacterTable ClassArray ClassBitmap ClassBlockContext ClassByteArray ClassCharacter ClassCompiledMethod ClassExternalAddress ClassExternalData ClassExternalFunction ClassExternalLibrary ClassExternalStructure ClassFloat ClassInteger ClassLargeNegativeInteger ClassLargePositiveInteger ClassMessage ClassMethodContext ClassPoint ClassProcess ClassPseudoContext ClassRedirector ClassSemaphore ClassString ClassTranslatedMethod CompactClassMask CompactClasses ConstMinusOne ConstOne ConstTwo ConstZero CtxtTempFrameStart DoAssertionChecks DoBalanceChecks Done ExternalObjectsArray FalseObject FloatProto GCTopMarker HashBits HashBitsOffset HeaderTypeClass HeaderTypeFree HeaderTypeGC HeaderTypeShort HeaderTypeSizeAndClass LargeContextBit LargeContextSize MarkBit MethodContextProto NilContext NilObject RemapBufferSize RootBit RootTableSize SchedulerAssociation SelectorAboutToReturn SelectorCannotInterpret SelectorCannotReturn SelectorDoesNotUnderstand SelectorEquivalenceForObjectAndRedirector SelectorMustBeBoolean SelectorRedirectMessage SizeMask SmallContextSize SpecialSelectors StackStart StartField StartObj TheDisplay TheFinalizationSemaphore TheInputSemaphore TheInterruptSemaphore TheLowSpaceSemaphore TheTimerSemaphore TrueObject TypeMask Upward '
	poolDictionaries: ''
	category: 'VMConstruction-Interpreter'!
ObjectMemory subclass: #Interpreter
	instanceVariableNames: 'activeContext theHomeContext method receiver instructionPointer stackPointer localIP localSP localHomeContext messageSelector argumentCount newMethod currentBytecode successFlag primitiveIndex methodCache atCache lkupClass reclaimableContextCount nextPollTick nextWakeupTick lastTick interruptKeycode interruptPending semaphoresToSignalA semaphoresUseBufferA semaphoresToSignalCountA semaphoresToSignalB semaphoresToSignalCountB savedWindowSize fullScreenFlag deferDisplayUpdates pendingFinalizationSignals compilerInitialized compilerHooks extraVMMemory newNativeMethod methodClass receiverClass interpreterVersion obsoleteIndexedPrimitiveTable obsoleteNamedPrimitiveTable interpreterProxy showSurfaceFn interruptCheckCounterFeedBackReset interruptChecksEveryNms externalPrimitiveTable redirectorMask '
	classVariableNames: 'ActiveProcessIndex AtCacheEntries AtCacheFixedFields AtCacheFmt AtCacheMask AtCacheOop AtCacheSize AtCacheTotalSize AtPutBase BlockArgumentCountIndex BytecodeTable CacheProbeMax CallerIndex CharacterValueIndex CompilerHooksSize CrossedX DirBadPath DirEntryFound DirNoMoreEntries EndOfRun ExcessSignalsIndex FirstLinkIndex GenerateBrowserPlugin HeaderIndex HomeIndex InitialIPIndex InstanceSpecificationIndex InstructionPointerIndex JitterTable LastLinkIndex LiteralStart MaxExternalPrimitiveTableSize MaxPrimitiveIndex MessageArgumentsIndex MessageDictionaryIndex MessageLookupClassIndex MessageSelectorIndex MethodArrayIndex MethodCacheClass MethodCacheEntries MethodCacheEntrySize MethodCacheMask MethodCacheMethod MethodCacheNative MethodCachePrim MethodCacheSelector MethodCacheSize MethodIndex MillisecondClockMask MyListIndex NextLinkIndex PrimitiveExternalCallIndex PrimitiveTable PriorityIndex ProcessListsIndex ReceiverIndex SelectorStart SemaphoresToSignalSize SenderIndex StackPointerIndex StreamArrayIndex StreamIndexIndex StreamReadLimitIndex StreamWriteLimitIndex SuperclassIndex SuspendedContextIndex TempFrameStart ValueIndex XIndex YIndex '
	poolDictionaries: ''
	category: 'VMConstruction-Interpreter'!
TestCase subclass: #ProxyTestCase
	instanceVariableNames: 'proxy object '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Redirector Tests'!
Object subclass: #RedirectionManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Redirector'!

!RedirectionManager commentStamp: '<historical>' prior: 0!
comment

	Smalltalk garbageCollect.

	"Check for turds"
	MessageRedirector allInstances.
	MessageRedirectorProxy allInstances.
	RedirectorContext allInstances.
	RedirectorMixin allInstances.
	BehavioralRedirectorContext allInstances.


	"Check for activation"
	RedirectionManager isEnabled.
	RedirectionManager enable.
	RedirectionManager disable.

	"Create a new Mixin behavior...and use it"
	RedirectorMixin newNamed: 'ProxyMixin'.
	(ProxyMixin proxyOn: Processor) inspect.


	"Two-way equivalence test"
[
	| proxant proxy |
	proxant := Dictionary new 
		at: #hello put: 'world'; 
		yourself.
	proxy := RedirectorContext on: proxant.
	Transcript cr; show: (proxant == proxy) printString.
	Transcript cr; show: (proxy == proxant) printString].


	events
	redirectors
	futures
	tasks
	queues/processes
	async sending
	farRef/promiseRef/brokenRef/nearRef
	serializer
	client server framework
	chatter distributed objects
	distGC
	distProcess
	distInspector
	distStackFrame
	distDebugger
	linda


vm: normal image: normal
0 tinyBenchmarks
 '120300751 bytecodes/sec; 3425013 sends/sec'

vm: redirect image: redirect
0 tinyBenchmarks
 '121327014 bytecodes/sec; 3390363 sends/sec'
!

Object subclass: #RedirectorContext
	instanceVariableNames: 'target redirector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Redirector'!
RedirectorContext subclass: #BehavioralRedirectorContext
	instanceVariableNames: 'behavior '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Redirector'!
RedirectorContext class
	instanceVariableNames: 'redirectionMethodDictionary '!
ClassDescription subclass: #RedirectorMixin
	instanceVariableNames: 'contextClass name environment '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Redirector'!
TestCase subclass: #RedirectorTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Redirector Tests'!

!ProtoObject methodsFor: 'comparing' stamp: 'rw 1/5/2002 16:34'!
yourself
	"Answer self."! !

!ProtoObject methodsFor: 'inspection' stamp: 'rww 1/12/2002 19:23'!
class
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!ProtoObject methodsFor: 'inspection' stamp: 'rww 1/12/2002 19:29'!
defaultLabelForInspector
	"Answer the default label to be used for an Inspector window on the receiver."

	^ self class name! !

!ProtoObject methodsFor: 'inspection' stamp: 'rww 1/12/2002 19:28'!
inspect
	"Create and schedule an Inspector in which the user can examine the receiver's variables."

	Inspector openOn: self withEvalPane: true! !

!ProtoObject methodsFor: 'inspection' stamp: 'rww 1/12/2002 19:28'!
isKindOf: aClass 
	"Answer whether the class, aClass, is a superclass or class of the receiver."

	self class == aClass
		ifTrue: [^true]
		ifFalse: [^self class inheritsFrom: aClass]! !


!Class methodsFor: 'subclass creation' stamp: 'rww 1/27/2002 15:13'!
mixinSubclass: t contextClass: aContextClass instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat 
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class (the receiver)."
	^(ClassBuilder new)
		superclass: self
		mixinSubclass: t 
		contextClass: aContextClass 
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat
! !


!ClassBuilder methodsFor: 'mixin class definition' stamp: 'rww 1/27/2002 15:10'!
name: className inEnvironment: env mixinSubclassOf: newSuper contextClass: aContextClass type: type instanceVariableNames: instVarString classVariableNames: classVarString poolDictionaries: poolString category: category
	"Define a new class in the given environment"
	^self 
		name: className 
		inEnvironment: env 
		mixinSubclassOf: newSuper 
		contextClass: aContextClass
		type: type 
		instanceVariableNames: instVarString 
		classVariableNames: classVarString 
		poolDictionaries: poolString 
		category: category
		unsafe: false! !

!ClassBuilder methodsFor: 'mixin class definition' stamp: 'rww 1/27/2002 16:30'!
name: className inEnvironment: env mixinSubclassOf: newSuper contextClass: aContextClass type: type instanceVariableNames: instVarString classVariableNames: classVarString poolDictionaries: poolString category: category unsafe: unsafe
	"Define a new class in the given environment.
	If unsafe is true do not run any validation checks.
	This facility is provided to implement important system changes."
	| oldClass newClass organization instVars classVars force |
	environ _ env.
	instVars _ Scanner new scanFieldNames: instVarString.
	classVars _ (Scanner new scanFieldNames: classVarString) collect: [:x | x asSymbol].

	"Validate the proposed name"
	unsafe ifFalse:[(self validateClassName: className) ifFalse:[^nil]].
	oldClass _ env at: className ifAbsent:[nil].
	oldClass isBehavior 
		ifFalse:[oldClass _ nil]. "Already checked in #validateClassName:"

	unsafe ifFalse:[
		"Run validation checks so we know that we have a good chance for recompilation"
		(self validateSuperclass: newSuper forSubclass: oldClass) ifFalse:[^nil].
		(self validateInstvars: instVars from: oldClass forSuper: newSuper) ifFalse:[^nil].
		(self validateClassvars: classVars from: oldClass forSuper: newSuper) ifFalse:[^nil].
		(self validateSubclassFormat: type from: oldClass forSuper: newSuper extra: instVars size) ifFalse:[^nil]].

	"Create a template for the new class (will return oldClass when there is no change)"
	newClass _ self 
		newMixinSubclassOf: newSuper 
		contextClass: aContextClass
		type: type 
		instanceVariables: instVars
		from: oldClass
		unsafe: unsafe.

	newClass == nil ifTrue:[^nil]. "Some error"

	newClass == oldClass ifFalse:[newClass setName: className asSymbol].

	"Install the class variables and pool dictionaries... "
	force _ (newClass declare: classVarString) | (newClass sharing: poolString).

	"... classify ..."
	organization _ environ ifNotNil:[environ organization].
	organization classify: newClass name under: category asSymbol.
	newClass environment: environ.

	"... export if not yet done ..."
	(environ at: newClass name ifAbsent:[nil]) == newClass ifFalse:[
		[environ at: newClass name put: newClass]
			on: AttemptToWriteReadOnlyGlobal do:[:ex| ex resume: true].
		Smalltalk flushClassNameCache.
	].

	"... recompile ..."
	newClass _ self recompile: force from: oldClass to: newClass mutate: false.

	self doneCompiling: newClass.
	^newClass
! !

!ClassBuilder methodsFor: 'mixin class definition' stamp: 'rww 1/27/2002 16:23'!
newMixinSubclassOf: newSuper contextClass: aContextClass type: type instanceVariables: instVars from: oldClass unsafe: unsafe
	"Create a new subclass of the given superclass.
	Note: The new class may be meta."
	| newFormat newClass meta |
	"Compute the format of the new class"
	newFormat _ 
		self computeFormat: type 
			instSize: instVars size 
			forSuper: newSuper 
			ccIndex: (oldClass ifNil:[0] ifNotNil:[oldClass indexIfCompact]).
	newFormat == nil ifTrue:[^nil].

	"Check if we really need a new subclass"
	(oldClass ~~ nil and:[
		newSuper == oldClass superclass and:[
			newFormat = oldClass format and:[
				instVars = oldClass instVarNames]]]) 
					ifTrue:[^oldClass].

	unsafe ifFalse:[
		"Make sure we don't redefine any dangerous classes"
		(self tooDangerousClasses includes: oldClass name) ifTrue:[
			self error: oldClass name, ' cannot be changed'.
			^nil].

		"Check if the receiver should not be redefined"
		(oldClass ~~ nil and:[oldClass shouldNotBeRedefined]) ifTrue:[
			self notify: oldClass name asText allBold, 
						' should not be redefined!! \Proceed to store over it.' withCRs]].

	oldClass == nil ifTrue:["Requires new metaclass"
		meta _ Metaclass new.
		meta
			superclass: RedirectorMixin
			methodDictionary: MethodDictionary new
			format: RedirectorMixin format.
		newClass _ meta new.
	] ifFalse:[ newClass _ oldClass shallowCopy ].
	newClass 
		superclass: newSuper
		methodDictionary: MethodDictionary new
		format: newFormat;
		contextClass: aContextClass;
		setInstVarNames: instVars;
		organization: (oldClass ifNotNil:[oldClass organization]).
	^newClass! !

!ClassBuilder methodsFor: 'mixin class definition' stamp: 'rww 1/27/2002 15:10'!
superclass: newSuper
	mixinSubclass: t contextClass: aContextClass instanceVariableNames: f 
	classVariableNames: d poolDictionaries: s category: cat 
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class."
	^self 
		name: t
		inEnvironment: newSuper environment
		mixinSubclassOf: newSuper
		contextClass: aContextClass
		type: newSuper typeOfClass
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat
! !


!ExecuteCompiledMethodTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:10'!
testNoArgsExecuteCompiledMethod

	| object method result |
	object := Object new.
	method := object class lookupSelector: #printString.
	result := RedirectionManager executeCompiledMethod: method onReceiver: object.
	self assert: result = object printString.! !

!ExecuteCompiledMethodTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:11'!
testWith1ArgExecuteCompiledMethod


	| object method result |
	object := OrderedCollection new.
	method := object class lookupSelector: #add:.
	self 
		shouldnt: [result := RedirectionManager
			executeCompiledMethod: method 
			onReceiver: object 
			withArguments: #(hello)]
		raise: Error.
	self assert: result = #hello.! !

!ExecuteCompiledMethodTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:11'!
testWith2ArgsExecuteCompiledMethod


	| object method result |
	object := Dictionary new.
	method := object class lookupSelector: #at:put:.
	self
		shouldnt: [result := RedirectionManager
			executeCompiledMethod: method 
			onReceiver: object 
			withArguments: #(hello world)]
		raise: Error.
	self assert: result = #world.
	
! !


!MessageRedirector class methodsFor: 'instance creation' stamp: 'rw 12/25/2001 16:10'!
basicNew

	self shouldNotImplement! !

!MessageRedirector class methodsFor: 'instance creation' stamp: 'rw 12/25/2001 15:04'!
new

	self shouldNotImplement! !


!MessageRedirectorProxy methodsFor: 'as yet unclassified' stamp: 'rw 3/24/2002 23:29'!
class

	^ context class! !

!MessageRedirectorProxy methodsFor: 'as yet unclassified' stamp: 'rw 3/17/2002 01:42'!
doesNotUnderstand: aMessage

	^context redirectMessage: aMessage.
! !

!MessageRedirectorProxy methodsFor: 'as yet unclassified' stamp: 'rw 2/16/2002 21:16'!
xxxInstVarAt: anInteger put: anObject 
	"Primitive. Store a value into a fixed variable in the receiver. The 
	numbering of the variables corresponds to the named instance variables. 
	Fail if the index is not an Integer or is not the index of a fixed variable. 
	Answer the value stored as the result. Using this message violates the 
	principle that each object has sovereign control over the storing of 
	values into its instance variables. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 74>
	self primitiveFailed ! !


!MessageRedirectorProxy class methodsFor: 'as yet unclassified' stamp: 'rw 2/16/2002 21:16'!
newOn: anObject

	^super new
		xxxInstVarAt: 1 put: anObject;
		yourself! !


!Interpreter methodsFor: 'initialization' stamp: 'rw 12/21/2001 01:14'!
initializeInterpreter: bytesToShift
	"Initialize Interpreter state before starting execution of a new image."

	interpreterProxy _ self sqGetInterpreterProxy.
	self initializeObjectMemory: bytesToShift.
	self initCompilerHooks.
	self flushExternalPrimitives.

	activeContext	_ nilObj.
	theHomeContext	_ nilObj.
	method			_ nilObj.
	receiver		_ nilObj.
	messageSelector	_ nilObj.
	newMethod		_ nilObj.
	methodClass		_ nilObj.
	lkupClass		_ nilObj.
	receiverClass	_ nilObj.
	newNativeMethod		_ nilObj.

	self flushMethodCache.
	self loadInitialContext.
	interruptCheckCounter _ 0.
	interruptCheckCounterFeedBackReset _ 1000.
	interruptChecksEveryNms _ 5.
	nextPollTick _ 0.
	nextWakeupTick _ 0.
	lastTick _ 0.
	interruptKeycode _ 2094.  "cmd-."
	interruptPending _ false.
	semaphoresUseBufferA _ true.
	semaphoresToSignalCountA _ 0.
	semaphoresToSignalCountB _ 0.
	deferDisplayUpdates _ false.
	pendingFinalizationSignals _ 0.

	redirectorMask _ 0.
! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/21/2001 22:29'!
dumpOop: object

	| hdr fmt objectType ccIndex totalLength objectClass classHdr szClassHdr classType classCcIndex classObjFmt |
	self inline: true.

	(self isIntegerObject: object)
		ifTrue: [^nil].
	hdr := self baseHeader: object.
	fmt := self formatOf: object.
	objectType := hdr bitAnd: TypeMask.
	ccIndex _ (hdr >> 12) bitAnd: 16r1F.    "bit shift 12 to the right"
	totalLength _ self lengthOf: object.

	objectClass := self fetchClassOf: object.
	classHdr := self formatOfClass: objectClass.
	szClassHdr := classHdr bitAnd: 16r1FFFF.
	classType := szClassHdr bitAnd: TypeMask.
	classCcIndex _ (szClassHdr >> 12) bitAnd: 16r1F.    "bit shift 12 to the right"
	classObjFmt _ (szClassHdr >> 8) bitAnd: 16rF.

	self cr.
	self print: 'object dump '.
	self cr.
	self print: '    object hdr: '.
	self printNum: hdr.
	self print: '  fmt: '.
	self printNum: fmt.
	self print: '  type: '.
	self printNum: objectType.
	self print: '  ccIndex: '.
	self printNum: ccIndex.
	self print: '  length: '.
	self printNum: totalLength.
	self print: '  class: '.
	self printNameOfClass: objectClass count: 3.
	self print: ' cls ccIndex: '.
	self printNum: classCcIndex.
	self cr.! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/23/2001 00:24'!
isRedirectorObject: oop

	self inline: true.

	(self isIntegerObject: oop) ifTrue: [^false].
	^ redirectorMask and: [(((self baseHeader: oop) >> 12) bitAnd: 16r1F) = redirectorMask].
! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/21/2001 02:28'!
primitiveAsOopForRedirector

	| redirector |
	self export: true.

	redirector _ self popStack.
	self popStack.
	self success: (self isIntegerObject: redirector) not.
	successFlag
		ifTrue: [self pushInteger: (self hashBitsOf: redirector)]
		ifFalse: [self unPop: 2]
! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/21/2001 02:26'!
primitiveCloneForRedirector

	| newCopy |
	self export: true.

	newCopy _ self clone: (self stackTop).
	self pop: 2 thenPush: newCopy.
! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/26/2001 11:54'!
primitiveCreateRedirectorOnContext

	| hdr fmt totalLength redirector redirectorContext |
	self export: true.

	redirectorContext := self stackObjectValue: 0.
	(redirectorMask = 0)
		ifTrue: [^successFlag _ false].
	redirector _ self instantiateClass: (self splObj: ClassRedirector) indexableSize: 0.
	self beRootIfOld: redirector.
	"Ensure that the Prototype is big enough"
	hdr _ self baseHeader: redirector.
	fmt _ (hdr >> 8) bitAnd: 16rF.
	totalLength _ self lengthOf: redirector baseHeader: hdr format: fmt.
	(totalLength > 0) 
		ifFalse: [^ successFlag _ false ].
	self storePointer: 0 ofObject: redirector withValue: redirectorContext.
	self pop: 2 thenPush: redirector.
! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/26/2001 11:15'!
primitiveDisableRedirection

	self export: true.

	redirectorMask _ 0.
! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/26/2001 11:13'!
primitiveEnableRedirectionWithCompactClassIndex

	| redirectorCCIndex |
	self export: true.

	redirectorCCIndex := self popInteger.
	redirectorMask _ redirectorCCIndex.
! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/20/2001 23:40'!
primitiveExecuteCompiledMethodOnReceiver

	| newReceiver methodToBeExecuted |
	self export: true.

	self success: (argumentCount = 2).
	successFlag ifFalse: [^ successFlag].
	newReceiver _ self popStack.
	methodToBeExecuted _ self popStack.
	self success: ((self argumentCountOf: methodToBeExecuted) = 0).
	successFlag ifFalse: [^ self unPop: 2].
	self assertClassOf: methodToBeExecuted is: (self splObj: ClassCompiledMethod).
	successFlag ifFalse: [^ self unPop: 2].
	self popStack.				"Pop the old receiver"
	self push: newReceiver.		"Push the new receiver"
	receiverClass _ lkupClass _ self fetchClassOf: newReceiver.
	argumentCount _ 0.
	newMethod _ methodToBeExecuted.
	methodClass _ receiverClass.
	self executeNewMethod.  "Recursive xeq affects successFlag"
	successFlag _ true.
! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/20/2001 23:40'!
primitiveExecuteCompiledMethodOnReceiverWithArgs

	| argumentArray newReceiver methodToBeExecuted arrayArgumentCount cntxSize index |
	self export: true.

	self success: (argumentCount = 3).
	successFlag ifFalse: [^ successFlag].
	argumentArray _ self popStack.
	newReceiver _ self popStack.
	methodToBeExecuted _ self popStack.
	self assertClassOf: argumentArray is: (self splObj: ClassArray).
	successFlag ifFalse: [^ self unPop: 3].
	arrayArgumentCount _ self fetchWordLengthOf: argumentArray.
	cntxSize _ self fetchWordLengthOf: activeContext.
	self success: ((self stackPointerIndex + arrayArgumentCount) < cntxSize).
	successFlag ifFalse: [^ self unPop: 3].
	self success: ((self argumentCountOf: methodToBeExecuted) = arrayArgumentCount).
	successFlag ifFalse: [^ self unPop: 3].
	self assertClassOf: methodToBeExecuted is: (self splObj: ClassCompiledMethod).
	successFlag ifFalse: [^ self unPop: 3].
	self popStack.				"Pop the old receiver"
	self push: newReceiver.		"Push the new receiver"
	receiverClass _ lkupClass _ self fetchClassOf: newReceiver.
	newMethod _ methodToBeExecuted.
	methodClass _ receiverClass.
	"Copy the arguments to the stack, and execute"
	index _ 1.
	[index <= arrayArgumentCount]
		whileTrue:
		[self push: (self fetchPointer: index - 1 ofObject: argumentArray).
		index _ index + 1].
	argumentCount _ arrayArgumentCount.
	self executeNewMethod.  "Recursive xeq affects successFlag"
	successFlag _ true.
! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 1/8/2002 01:31'!
primitiveIsRedirectionEnabled

	self export: true.

	self popStack.
	self pushBool: (redirectorMask > 0).

! !

!Interpreter methodsFor: 'redirectors' stamp: 'rww 1/13/2002 01:30'!
primitiveIsRedirectorObject

	| oop |
	self export: true.
	oop := self stackValue: 0.
	self popStack.
	^self pushBool: (self isRedirectorObject: oop).! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/21/2001 02:29'!
primitiveNextInstanceForRedirector

	| redirector instance |
	self export: true.

	redirector _ self popStack.
	instance _ self instanceAfter: redirector.
	instance = nilObj
		ifTrue: [self unPop: 1. self primitiveFail]
		ifFalse: [self pop: 1 thenPush: instance]! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/21/2001 02:30'!
primitiveNextObjectForRedirector

	| object instance |
	self export: true.

	object _ self popStack.
	self popStack.
	instance _ self accessibleObjectAfter: object.
	instance = nil
		ifTrue: [ self pushInteger: 0 ]
		ifFalse: [ self push: instance ].! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 4/6/2002 15:34'!
primitiveSwitchRedirectorToContext

	| redirector redirectorContext hdr1 hdr2 |
	self export: true.

	redirectorContext := self stackObjectValue: 0.
	redirector := self stackObjectValue: 1.
	(redirectorMask = 0)
		ifTrue: [^successFlag _ false].
	((self fetchClassOf: redirector) == (self splObj: ClassRedirector))
		ifFalse: [^successFlag _ false].
 	hdr1 _ self longAt: (self fetchPointer: 0 ofObject: redirector).
	hdr2 _ self longAt: redirectorContext.
	self longAt: redirectorContext put:
		((hdr2 bitAnd: AllButHashBits) bitOr: (hdr1 bitAnd: HashBits)).
	self storePointer: 0 ofObject: redirector withValue: redirectorContext.
	self pop: 3 thenPush: redirector.
! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/22/2001 23:39'!
redirectionSend
	"Send the redirect message to the redirection manager, setting up the message object and extracting the redirector handle."
	"Assume: original messageSelector and original argumentCount have been set, and that the original receiver and original arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."

	| rcvr |
	self inline: true.

	rcvr _ self internalStackValue: argumentCount.
	self externalizeIPandSP.
	self setupRedirectionMethodFor: rcvr.
	self internalizeIPandSP.
	self internalExecuteNewMethod.
	self fetchNextBytecode.
! !

!Interpreter methodsFor: 'redirectors' stamp: 'rw 12/24/2001 22:02'!
setupRedirectionMethodFor: rcvr

	| msg redirectorContext redirectorContextClass |
	self inline: true.

	redirectorContext := self fetchPointer: 0 ofObject: rcvr.
	self pushRemappableOop: redirectorContext.
	self createActualMessageTo: redirectorContext.
	redirectorContext := self popRemappableOop.
	redirectorContextClass _ self fetchClassOf: redirectorContext.
	methodClass _ receiverClass _ lkupClass _ redirectorContextClass.
	msg := self popStack.      "Message object created above"
	self popStack.              "redirector receiver"
	self push: redirectorContext.  "new receiver - redirector context"
	self push: msg.              "Message object"
	argumentCount _ 1.
	messageSelector _ self splObj: SelectorRedirectMessage.
	^self lookupMethodInClass: lkupClass.
! !

!Interpreter methodsFor: 'message sending' stamp: 'rw 12/26/2001 11:19'!
lookupMethodInClass: class
	| currentClass dictionary found rclass rcvr |
	self inline: false.

	rcvr := self stackValue: argumentCount.

	(self isRedirectorObject: rcvr)
		ifTrue: [^self setupRedirectionMethodFor: rcvr].

	currentClass _ class.
	[currentClass ~= nilObj]
		whileTrue:
		[
		dictionary _ self 
			fetchPointer: MessageDictionaryIndex 
			ofObject: currentClass.
		dictionary = nilObj ifTrue:
			["MethodDict pointer is nil (hopefully due a swapped out stub)
				-- raise exception #cannotInterpret:."
			successFlag := true.
			self pushRemappableOop: currentClass.  "may cause GC!!"
			self createActualMessageTo: class.
			currentClass _ self popRemappableOop.
			messageSelector _ self splObj: SelectorCannotInterpret.
			^ self lookupMethodInClass: (self superclassOf: currentClass)].
		found _ self lookupMethodInDictionary: dictionary.
		found ifTrue: [^ methodClass _ currentClass].
		currentClass _ self superclassOf: currentClass].

	"Could not find #doesNotUnderstand: -- unrecoverable error."
	messageSelector = (self splObj: SelectorDoesNotUnderstand) ifTrue:
		[self error: 'Recursive not understood error encountered'].

	"Cound not find a normal message -- raise exception #doesNotUnderstand:"
	self pushRemappableOop: class.  "may cause GC!!"
	self createActualMessageTo: class.
	rclass _ self popRemappableOop.
	messageSelector _ self splObj: SelectorDoesNotUnderstand.
	^ self lookupMethodInClass: rclass! !

!Interpreter methodsFor: 'common selector sends' stamp: 'rw 1/5/2002 14:42'!
bytecodePrimClass

	messageSelector _ self specialSelector: 23.
	argumentCount _ 0.
	^self normalSend.
! !

!Interpreter methodsFor: 'common selector sends' stamp: 'rw 1/5/2002 16:29'!
bytecodePrimEquivalent

	messageSelector _ self specialSelector: 22.
	argumentCount _ 1.
	^self normalSend.
! !


!ObjectMemory class methodsFor: 'initialization' stamp: 'rw 1/5/2002 18:34'!
initializeSpecialObjectIndices
	"Initialize indices into specialObjects array."

	NilObject _ 0.
	FalseObject _ 1.
	TrueObject _ 2.
	SchedulerAssociation _ 3.
	ClassBitmap _ 4.
	ClassInteger _ 5.
	ClassString _ 6.
	ClassArray _ 7.
	"SmalltalkDictionary _ 8."  "Do not delete!!"
	ClassFloat _ 9.
	ClassMethodContext _ 10.
	ClassBlockContext _ 11.
	ClassPoint _ 12.
	ClassLargePositiveInteger _ 13.
	TheDisplay _ 14.
	ClassMessage _ 15.
	ClassCompiledMethod _ 16.
	TheLowSpaceSemaphore _ 17.
	ClassSemaphore _ 18.
	ClassCharacter _ 19.
	SelectorDoesNotUnderstand _ 20.
	SelectorCannotReturn _ 21.
	TheInputSemaphore _ 22.
	SpecialSelectors _ 23.
	CharacterTable _ 24.
	SelectorMustBeBoolean _ 25.
	ClassByteArray _ 26.
	ClassProcess _ 27.
	CompactClasses _ 28.
	TheTimerSemaphore _ 29.
	TheInterruptSemaphore _ 30.
	FloatProto _ 31.
	SelectorCannotInterpret _ 34.
	MethodContextProto _ 35.
	BlockContextProto _ 37.
	ExternalObjectsArray _ 38.
	ClassPseudoContext _ 39.
	ClassTranslatedMethod _ 40.
	TheFinalizationSemaphore _ 41.
	ClassLargeNegativeInteger _ 42.

	ClassExternalAddress _ 43.
	ClassExternalStructure _ 44.
	ClassExternalData _ 45.
	ClassExternalFunction _ 46.
	ClassExternalLibrary _ 47.
 
	SelectorAboutToReturn _ 48.
	ClassRedirector _ 49.
	SelectorRedirectMessage _ 50.
! !


!ProxyTestCase methodsFor: 'tests' stamp: 'rww 1/13/2002 18:24'!
testAsOop

	"Check basic operation of a proxy"
	self deny: (self proxy asOop == self object asOop).
! !

!ProxyTestCase methodsFor: 'tests' stamp: 'rww 1/13/2002 18:24'!
testClass

	"Check basic operation of a redirector"
	self assert: (self proxy class = Object).
! !

!ProxyTestCase methodsFor: 'tests' stamp: 'rww 1/13/2002 18:31'!
testClone

	"Check basic operation of a redirector"
	self deny: (self proxy clone == self object clone).
	self assert: (self proxy clone = object).
! !

!ProxyTestCase methodsFor: 'tests' stamp: 'rww 1/13/2002 18:25'!
testEquivalenceProxyArgument

	"Check basic operation of a redirector"
	self assert: (object == proxy).

! !

!ProxyTestCase methodsFor: 'tests' stamp: 'rww 1/13/2002 18:25'!
testEquivalenceProxyReceiver

	"Check basic operation of a redirector"
	self assert: (proxy == object).
! !

!ProxyTestCase methodsFor: 'tests' stamp: 'rww 1/13/2002 18:25'!
testHash

	"Check basic operation of a redirector"
	self assert: (proxy hash = object hash).
! !

!ProxyTestCase methodsFor: 'tests' stamp: 'rw 2/10/2002 17:24'!
testNextInstance

	"Check basic operation of a redirector"
	| nextInstance count |
	nextInstance := Proxy someInstance.
	count := 0.
	[nextInstance isNil]
		whileFalse: 
			[count := count + 1.
			nextInstance := nextInstance nextInstance].
	self assert: (count > 0).! !

!ProxyTestCase methodsFor: 'tests' stamp: 'rww 1/13/2002 18:26'!
testNextObject

	"Check basic operation of a redirector"
	self assert: (proxy nextObject notNil).

! !

!ProxyTestCase methodsFor: 'tests' stamp: 'rww 1/13/2002 18:26'!
testNoErrorWhenEnabled

	"Check for an error for creating an incorrect proxy"
	self shouldnt: [proxy yourself] raise: Error.
! !

!ProxyTestCase methodsFor: 'tests' stamp: 'rww 1/13/2002 18:26'!
testPrintString

	"Check basic operation of a redirector"
	self assert: (proxy printString = 'an Object').
! !

!ProxyTestCase methodsFor: 'tests' stamp: 'rww 1/13/2002 18:26'!
testReturn

	"Check basic operation of a redirector"
	self assert: (proxy beep printString = 'an Object').
! !

!ProxyTestCase methodsFor: 'tests' stamp: 'rw 2/10/2002 17:24'!
testSomeInstance

	"Check basic operation of a redirector"
	proxy := Proxy newOn: Object.
	self shouldnt: [proxy someInstance] raise: Error.
! !

!ProxyTestCase methodsFor: 'fixtures' stamp: 'rww 1/13/2002 18:23'!
object

	^object! !

!ProxyTestCase methodsFor: 'fixtures' stamp: 'rww 1/13/2002 18:23'!
proxy

	^proxy! !

!ProxyTestCase methodsFor: 'fixtures' stamp: 'rw 3/10/2002 17:22'!
setUp

	super setUp.
	object := Object new.
	proxy := MessageRedirectorProxy newOn: object.
! !

!ProxyTestCase methodsFor: 'fixtures' stamp: 'rww 1/13/2002 18:23'!
tearDown

	object := nil.
	proxy := nil.
	super tearDown.! !


!RedirectionManager class methodsFor: 'redirector mop' stamp: 'rw 3/10/2002 16:46'!
asOopForRedirector: aRedirector

	^ self primAsOopForRedirector: aRedirector! !

!RedirectionManager class methodsFor: 'redirector mop' stamp: 'rw 3/24/2002 13:22'!
becomeContext: aContext forRedirector: redirector

	self primSwitchRedirector: redirector toContext: aContext! !

!RedirectionManager class methodsFor: 'redirector mop' stamp: 'rw 3/10/2002 16:47'!
cloneForRedirector: aRedirector

	^ self primCloneForRedirector: aRedirector! !

!RedirectionManager class methodsFor: 'redirector mop' stamp: 'rw 3/10/2002 16:47'!
createRedirectorOnContext: aContext

	^ self primCreateRedirectorOnContext: aContext! !

!RedirectionManager class methodsFor: 'redirector mop' stamp: 'rw 3/10/2002 16:44'!
isRedirectorObject: anObject

	^self primIsRedirectorObject: anObject! !

!RedirectionManager class methodsFor: 'redirector mop' stamp: 'rw 3/10/2002 16:59'!
nextInstanceForRedirector: aRedirector

	^ self primNextInstanceForRedirector: aRedirector! !

!RedirectionManager class methodsFor: 'redirector mop' stamp: 'rw 3/10/2002 17:00'!
nextObjectForRedirector: aRedirector

	^ self primNextObjectForRedirector: aRedirector! !

!RedirectionManager class methodsFor: 'executing compiled methods' stamp: 'rw 3/10/2002 16:59'!
executeCompiledMethod: aMethod onReceiver: aReceiver

	^self primExecuteCompiledMethod: aMethod onReceiver: aReceiver! !

!RedirectionManager class methodsFor: 'executing compiled methods' stamp: 'rw 3/10/2002 16:59'!
executeCompiledMethod: aMethod onReceiver: aReceiver withArguments: argArray

	^self primExecuteCompiledMethod: aMethod onReceiver: aReceiver withArguments: argArray! !

!RedirectionManager class methodsFor: 'control' stamp: 'rw 3/10/2002 16:44'!
disable

	self primDisableRedirection.
! !

!RedirectionManager class methodsFor: 'control' stamp: 'rw 3/10/2002 16:45'!
enable

	MessageRedirector flushCache.
	(MessageRedirector indexIfCompact > 0) ifFalse: [MessageRedirector becomeCompact].
	self primEnableRedirectionWithCompactClassIndex: MessageRedirector indexIfCompact.
! !

!RedirectionManager class methodsFor: 'control' stamp: 'rw 3/10/2002 16:44'!
isEnabled

	^self primIsRedirectionEnabled! !

!RedirectionManager class methodsFor: 'primitives' stamp: 'rw 3/10/2002 16:42'!
primAsOopForRedirector: aRedirector

	<primitive: 'primitiveAsOopForRedirector'>
	self error: 'redirection is disabled'.
! !

!RedirectionManager class methodsFor: 'primitives' stamp: 'rw 3/10/2002 16:42'!
primCloneForRedirector: aRedirector

	<primitive: 'primitiveCloneForRedirector'>
	self error: 'redirection is disabled'.
! !

!RedirectionManager class methodsFor: 'primitives' stamp: 'rw 3/10/2002 17:08'!
primCreateRedirectorOnContext: aContext

	<primitive: 'primitiveCreateRedirectorOnContext'>
	^MessageRedirectorProxy newOn: aContext! !

!RedirectionManager class methodsFor: 'primitives' stamp: 'rw 3/10/2002 16:43'!
primDisableRedirection

	<primitive: 'primitiveDisableRedirection'>
	self primitiveFailed! !

!RedirectionManager class methodsFor: 'primitives' stamp: 'rw 3/10/2002 16:43'!
primEnableRedirectionWithCompactClassIndex: index

	<primitive: 'primitiveEnableRedirectionWithCompactClassIndex'>
	self primitiveFailed! !

!RedirectionManager class methodsFor: 'primitives' stamp: 'rw 3/10/2002 16:43'!
primExecuteCompiledMethod: aMethod onReceiver: aReceiver

	<primitive: 'primitiveExecuteCompiledMethodOnReceiver'>
	self primitiveFailed! !

!RedirectionManager class methodsFor: 'primitives' stamp: 'rw 3/10/2002 16:43'!
primExecuteCompiledMethod: aMethod onReceiver: aReceiver withArguments: argArray

	<primitive: 'primitiveExecuteCompiledMethodOnReceiverWithArgs'>
	self primitiveFailed! !

!RedirectionManager class methodsFor: 'primitives' stamp: 'rw 3/10/2002 17:07'!
primIsRedirectionEnabled

	<primitive: 'primitiveIsRedirectionEnabled'>
	^false! !

!RedirectionManager class methodsFor: 'primitives' stamp: 'rw 3/10/2002 16:42'!
primIsRedirectorObject: anObject

	<primitive: 'primitiveIsRedirectorObject'>
	self error: 'redirection is disabled'.
! !

!RedirectionManager class methodsFor: 'primitives' stamp: 'rw 3/10/2002 16:42'!
primNextInstanceForRedirector: aRedirector

	<primitive: 'primitiveNextInstanceForRedirector'>
	^nil! !

!RedirectionManager class methodsFor: 'primitives' stamp: 'rw 3/10/2002 16:43'!
primNextObjectForRedirector: aRedirector

	<primitive: 'primitiveNextObjectForRedirector'>
	^0! !

!RedirectionManager class methodsFor: 'primitives' stamp: 'rw 3/16/2002 19:48'!
primSwitchRedirector: redirector toContext: aContext

	<primitive: 'primitiveSwitchRedirectorToContext'>
	^ redirector xxxInstVarAt: 1 put: aContext ! !


!RedirectorContext methodsFor: 'accessing' stamp: 'rw 3/16/2002 14:25'!
redirector

	^redirector! !

!RedirectorContext methodsFor: 'accessing' stamp: 'rw 12/23/2001 00:43'!
target
	^target! !

!RedirectorContext methodsFor: 'accessing' stamp: 'rw 12/23/2001 00:44'!
target: aTarget
	target := aTarget! !

!RedirectorContext methodsFor: 'message sending' stamp: 'rw 4/6/2002 12:36'!
becomeContext: aContext

	(Array with: self) elementsForwardIdentityTo: (Array with: aContext).
	aContext redirector: self redirector.
! !

!RedirectorContext methodsFor: 'message sending' stamp: 'rw 12/24/2001 09:48'!
redirectMessage: aMessage

	^self class redirectMessage: aMessage forContext: self! !

!RedirectorContext methodsFor: 'initialization' stamp: 'rw 3/16/2002 14:25'!
initialize

	redirector := RedirectionManager createRedirectorOnContext: self! !


!BehavioralRedirectorContext methodsFor: 'message sending' stamp: 'rww 1/15/2002 03:15'!
behavior

	^behavior! !

!BehavioralRedirectorContext methodsFor: 'message sending' stamp: 'rww 1/15/2002 03:15'!
behavior: aBehavior

	behavior := aBehavior! !

!BehavioralRedirectorContext methodsFor: 'message sending' stamp: 'rww 1/15/2002 04:02'!
redirectMessage: aMessage

	| returnValue |
	returnValue := self.
	[returnValue := self behavior invokeMessage: aMessage forContext: self]
		ensure:
			[(returnValue == self target)
				ifTrue: [returnValue := self redirector]].
	^returnValue! !


!RedirectorContext class methodsFor: 'accessing method dictionary' stamp: 'rw 12/24/2001 10:06'!
compiledMethodForRedirectionAt: selector 
	"Answer the compiled method associated with the argument, selector (a 
	Symbol), a message selector in the receiver's method dictionary. If the 
	selector is not in the dictionary, create an error notification."

	^ self redirectionMethodDict at: selector! !

!RedirectorContext class methodsFor: 'accessing method dictionary' stamp: 'rw 12/24/2001 10:06'!
compiledMethodForRedirectionAt: selector ifAbsent: aBlock
	"Answer the compiled method associated with the argument, selector (a Symbol), a message selector in the receiver's method dictionary. If the selector is not in the dictionary, return the value of aBlock"

	^ self redirectionMethodDict at: selector ifAbsent: [aBlock value]! !

!RedirectorContext class methodsFor: 'accessing method dictionary' stamp: 'rw 12/24/2001 09:58'!
includesSelectorForRedirection: aSymbol 
	"Answer whether the message whose selector is the argument is in the 
	method dictionary of the receiver's class."

	^ self redirectionMethodDict includesKey: aSymbol! !

!RedirectorContext class methodsFor: 'accessing method dictionary' stamp: 'rw 12/24/2001 10:04'!
lookupSelectorForRedirection: selector

	"Look up the given selector in my methodDictionary.
	Return the corresponding method if found.
	Otherwise chase the superclass chain and try again.
	Return nil if no method is found."
	| lookupClass |
	lookupClass _ self.
	[(Object == lookupClass) 
		or: [(ProtoObject == lookupClass) 
			or: [nil == lookupClass]]]
		whileFalse: 
			[(lookupClass includesSelectorForRedirection: selector)
				ifTrue: [^ lookupClass compiledMethodForRedirectionAt: selector].
			lookupClass _ lookupClass superclass].
	^ nil! !

!RedirectorContext class methodsFor: 'accessing method dictionary' stamp: 'rw 12/24/2001 17:22'!
redirectionMethodDict

	redirectionMethodDictionary isNil ifTrue: 
		[self redirectionMethodDict: MethodDictionary new].
	^redirectionMethodDictionary
! !

!RedirectorContext class methodsFor: 'accessing method dictionary' stamp: 'rw 12/24/2001 09:41'!
redirectionMethodDict: aDict

	redirectionMethodDictionary := aDict
! !

!RedirectorContext class methodsFor: 'control' stamp: 'rw 1/5/2002 19:27'!
initialize

	Smalltalk recreateSpecialObjectsArray.
	RedirectorContext installBaseMethods.
! !

!RedirectorContext class methodsFor: 'control' stamp: 'rw 3/16/2002 14:24'!
new

	^ super new initialize; yourself! !

!RedirectorContext class methodsFor: 'control' stamp: 'rw 3/16/2002 14:23'!
newOn: anObject

	| context |
	context := self new.
	context target: anObject.
	^ context redirector
! !

!RedirectorContext class methodsFor: 'control' stamp: 'rw 3/16/2002 14:12'!
on: anObject

	| context |
	context := self new.
	context target: anObject.
	^ context redirector
! !

!RedirectorContext class methodsFor: 'message sending' stamp: 'rw 3/10/2002 17:05'!
redirectMessage: aMessage forContext: aContext

	| selector arguments returnValue compiledMethod |
	selector := aMessage selector.
	arguments := aMessage arguments.
	returnValue := aContext redirector.

	[returnValue := (self includesSelectorForRedirection: selector) 
		ifTrue: 
			[compiledMethod := self compiledMethodForRedirectionAt: selector.
			RedirectionManager 
				executeCompiledMethod: compiledMethod 
				onReceiver: aContext 
				withArguments: arguments]
		ifFalse: 
			[aContext target perform: selector withArguments: arguments]]
				ensure:
					[(returnValue == aContext target)
						ifTrue: [returnValue := aContext redirector]].
	^returnValue! !

!RedirectorContext class methodsFor: 'compiling' stamp: 'rw 12/24/2001 09:57'!
addSelectorForRedirection: selector withMethod: compiledMethod 
	"Add the message selector with the corresponding compiled method to the 
	receiver's method dictionary."

	| oldMethod |
	oldMethod _ self lookupSelectorForRedirection: selector.
	self redirectionMethodDict at: selector put: compiledMethod.

	"Now flush Squeak's method cache, either by selector or by method"
	oldMethod == nil ifFalse: [oldMethod flushCache].
	selector flushCache! !

!RedirectorContext class methodsFor: 'compiling' stamp: 'rw 3/10/2002 17:03'!
baseMethodStrings

	^(OrderedCollection new)
		add: 'proxy		^RedirectorContext on: self redirector';
		add: '== arg		^self target == arg';
		add: 'basicEquivalence: arg		^self target basicEquivalence: arg';
		add: 'class		^self target class';
		add: '~~ arg		^self target ~~ arg';
		add: 'equivalenceForObject: object redirector: proxy  ^object == self target';
		add: 'isNil ^self target isNil';
		add: 'notNil ^self target notNil';
		add: 'ifNil: aBlock ^self target ifNil: aBlock';
		add: 'ifNotNil: aBlock ^self target ifNotNil: aBlock';
		add: 'hash ^self target hash';
		add: 'identityHash ^self target identityHash';
		add: 'yourself ^self redirector';
		add: 'inspect ^Inspector openOn: self redirector withEvalPane: true';
		add: 'printString ^self target printString, ''(r)''';
		add: 'debugPrintString ^self target debugPrintString, ''(r)''';
		add: 'longPrintString ^self target longPrintString, ''(r)''';
		add: 'printStringLimitedTo: size ^(self target printStringLimitedTo: size), ''(r)''';
		add: 'printOn: stream  self target printOn: stream.   stream nextPutAll: ''(r)''';
		add: 'debugPrintOn: stream  self target debugPrintOn: stream.   stream nextPutAll: ''(r)''';

		add: 'isProxy		^ RedirectionManager isRedirectorObject: self redirector';
		add: 'isRedirector		^ RedirectionManager isRedirectorObject: self redirector';
		add: 'asOop	^ RedirectionManager asOopForRedirector: self redirector';
		add: 'clone	^ RedirectionManager cloneForRedirector: self redirector';
		add: 'nextInstance	^ RedirectionManager nextInstanceForRedirector: self redirector';
		add: 'nextObject	^ RedirectionManager nextObjectForRedirector: self redirector';
		yourself
! !

!RedirectorContext class methodsFor: 'compiling' stamp: 'rw 12/24/2001 09:54'!
compileForRedirection: aString
	^self
		compileForRedirection: aString
		withMarker: 0! !

!RedirectorContext class methodsFor: 'compiling' stamp: 'rw 12/24/2001 09:56'!
compileForRedirection: code withMarker: anInteger
	"Simplified version for proxies"

	| methodNode selector method |
	methodNode _ self compilerClass new
				compile: code
				in: self
				notifying: nil
				ifFail: [:error | self error: error].
	selector _ methodNode selector.
	methodNode encoder requestor: nil.  "Why was this not preserved?"
	method _ methodNode generate: (#(0 0 0) copyWith: anInteger).
	anInteger = 0 ifTrue: [method _ method copyWithTempNames: methodNode tempNames].

	self addSelectorForRedirection: selector withMethod: method.
	^selector! !

!RedirectorContext class methodsFor: 'compiling' stamp: 'rw 12/24/2001 22:20'!
installBaseMethods

	self baseMethodStrings do: 
		[:eachMethodString |
		self compileForRedirection: eachMethodString].
! !

!RedirectorContext class methodsFor: 'performance tests' stamp: 'rw 12/24/2001 19:08'!
secondsToRunEachOverCount: count block: aBlock

	| timeToRun timePerInvocation |
	timeToRun := Time millisecondsToRun: [count timesRepeat: aBlock].
	timePerInvocation := (timeToRun / count / 1000) asFloat.
	^timePerInvocation
! !

!RedirectorContext class methodsFor: 'performance tests' stamp: 'rw 12/24/2001 19:18'!
testTiming: count creationBlock: creationBlock
	"RedirectorContext testTiming: 5000 creationBlock: [:obj | [obj printString] fixTemps]"
	"RedirectorContext testTiming: 5000 creationBlock: [:obj | [obj hash] fixTemps]"
	"RedirectorContext testTiming: 5000 creationBlock: [:obj | [obj yourself] fixTemps]"

	"Timings for message redirection"

	| object proxyTime objectTime proxyActivationTime |
	object := self on: 'hello world'.
	proxyTime := self secondsToRunEachOverCount: count block: (creationBlock value: object).
	object := 'hello world'.
	objectTime := self secondsToRunEachOverCount: count block: (creationBlock value: object).
	proxyActivationTime := proxyTime - objectTime.
	Transcript cr; show: 'time (micros) per proxy invocation: ',
		(proxyTime * 1000000) asInteger asStringWithCommas.
	Transcript cr; show: 'time (micros) per object invocation: ',
		(objectTime * 1000000) asInteger asStringWithCommas.
	Transcript cr; show: 'Proxy calls per second: ', 
		(1 / proxyActivationTime) asInteger asStringWithCommas.
! !


!BehavioralRedirectorContext class methodsFor: 'control' stamp: 'rw 3/16/2002 14:13'!
on: anObject withClass: aClass

	| context |
	context := self new.
	context target: anObject.
	context behavior: aClass.
	^ context redirector
! !


!RedirectorMixin methodsFor: 'invoking' stamp: 'rw 5/4/2002 10:12'!
invokeMessage: aMessage forContext: aContext
  
	| method |
	(aContext class includesBehavior: self contextClass)
		ifFalse: [^ self error: 'bad context class'].
	(self includesSelector: aMessage selector)
		ifFalse: [
			^ aContext target
				perform: aMessage selector
				withArguments: aMessage arguments].
	method := self methodDict at: aMessage selector.
	^ RedirectionManager
		executeCompiledMethod: method 
		onReceiver: aContext 
		withArguments: aMessage arguments.
 ! !

!RedirectorMixin methodsFor: 'compiling' stamp: 'rww 1/27/2002 16:43'!
compile: code notifying: requestor 
	"Compile the argument, code, as source code in the context of the 
	receiver and insEtall the result in the receiver's method dictionary. The 
	second argument, requestor, is to be notified if an error occurs. The 
	argument code is either a string or an object that converts to a string or 
	a PositionableStream. This method also saves the source code."

	| methodNode selector newMethod |
	methodNode _ self compilerClass new
				compile: code
				in: self contextClass
				notifying: requestor
				ifFail: [^nil].
	selector _ methodNode selector.
	methodNode encoder requestor: requestor.  "Why was this not preserved?" 
	newMethod _ methodNode generate: #(0 0 0 0).
	newMethod _ newMethod copyWithTempNames: methodNode tempNames.
	self addSelector: selector withMethod: newMethod.
	^ selector! !

!RedirectorMixin methodsFor: 'compiling' stamp: 'rww 1/27/2002 16:43'!
compile: code notifying: requestor trailer: bytes 
		ifFail: failBlock
		elseSetSelectorAndNode: selAndNodeBlock
	"Intercept this message in order to remember system changes.
	 5/15/96 sw: modified so that if the class does not wish its methods logged in the changes file, then they also won't be accumulated in the current change set.
	7/12/96 sw: use wantsChangeSetLogging to determine whether to put in change set"

	| methodNode selector newMethod |
	methodNode _ self compilerClass new
				compile: code
				in: self contextClass 
				notifying: requestor
				ifFail: failBlock.
	selector _ methodNode selector.
	selAndNodeBlock value: selector value: methodNode.
	methodNode encoder requestor: requestor.  "Why was this not preserved?"
	newMethod _ methodNode generate: bytes.
	bytes last = 0 ifTrue: [newMethod _ newMethod copyWithTempNames: methodNode tempNames].
	self addSelector: selector withMethod: newMethod.
	^ newMethod! !

!RedirectorMixin methodsFor: 'instance creation' stamp: 'rww 1/27/2002 16:42'!
categoryOfElement: aSymbol

	^'as yet unclassified' ! !

!RedirectorMixin methodsFor: 'instance creation' stamp: 'rww 1/27/2002 16:43'!
classPool

	^superclass 
		ifNil: [Dictionary new] 
		ifNotNil: [superclass classPool] ! !

!RedirectorMixin methodsFor: 'instance creation' stamp: 'rww 1/27/2002 16:43'!
new
	self error: 'disallowed' ! !

!RedirectorMixin methodsFor: 'instance creation' stamp: 'rww 1/27/2002 16:43'!
new: anInteger
	self error: 'disallowed' ! !

!RedirectorMixin methodsFor: 'instance creation' stamp: 'rww 1/27/2002 16:43'!
proxyOn: anObject

	^self contextClass on: anObject withClass: self
 ! !

!RedirectorMixin methodsFor: 'instance creation' stamp: 'rww 1/27/2002 16:43'!
scopeHas: varName ifTrue: assocBlock
	"Look up the first argument, varName, in the context of the receiver. If it is there,
	pass the association to the second argument, assocBlock, and answer true."

	| assoc |
	"First look in classVar dictionary."
	(assoc _ self classPool associationAt: varName ifAbsent: []) == nil
		ifFalse: [assocBlock value: assoc.
				^ true].

	"Next look in shared pools."
	self sharedPools do: 
		[:pool | 
		assoc _ pool associationAt: varName ifAbsent: [
			"String key hack from Hypersqueak now used in Wonderland  **Eliminate this**" 
			pool associationAt: varName asString ifAbsent: []].
		assoc == nil ifFalse: 
				[assocBlock value: assoc.
				^true]].

	"Next look in declared environment."
	(assoc _ self environment associationAtOrAbove: varName ifAbsent: [nil]) == nil
		ifFalse: [assocBlock value: assoc.
				^ true].

	"Finally look higher up the superclass chain and fail at the end."
	superclass == nil
		ifTrue: [^ false]
		ifFalse: [^ superclass scopeHas: varName ifTrue: assocBlock].

! !

!RedirectorMixin methodsFor: 'instance creation' stamp: 'rww 1/27/2002 16:43'!
sharedPools

	^superclass 
		ifNil: [OrderedCollection new] 
		ifNotNil: [superclass sharedPools] ! !

!RedirectorMixin methodsFor: 'accessing' stamp: 'rww 1/27/2002 16:43'!
contextClass

	^ contextClass ! !

!RedirectorMixin methodsFor: 'accessing' stamp: 'rww 1/27/2002 16:43'!
contextClass: aClass

	contextClass := aClass ! !

!RedirectorMixin methodsFor: 'accessing' stamp: 'rww 1/27/2002 16:43'!
environment

	environment == nil ifTrue: [^ super environment].
	^ environment ! !

!RedirectorMixin methodsFor: 'accessing' stamp: 'rww 1/27/2002 16:43'!
environment: anEnvironment

	environment _ anEnvironment ! !

!RedirectorMixin methodsFor: 'accessing' stamp: 'rww 1/27/2002 16:43'!
kindOfSubclass 
	"Answer a String that is the keyword that describes the receiver's kind
	of subclass, either a regular subclass, a variableSubclass, a 
	variableByteSubclass, a variableWordSubclass, or a weakSubclass."

	^' mixinSubclass: ' ! !

!RedirectorMixin methodsFor: 'accessing' stamp: 'rww 1/27/2002 16:43'!
methodDict
	methodDict == nil ifTrue: [methodDict := MethodDictionary new].
	^ methodDict ! !

!RedirectorMixin methodsFor: 'accessing' stamp: 'rww 1/27/2002 16:43'!
name

	^name ! !

!RedirectorMixin methodsFor: 'accessing' stamp: 'rww 1/27/2002 16:43'!
possibleVariablesFor: misspelled continuedFrom: oldResults

	| results |
	results _ misspelled correctAgainstDictionary: self classPool continuedFrom: oldResults.
	self sharedPools do: [:pool | 
		results _ misspelled correctAgainstDictionary: pool continuedFrom: results ].
	superclass == nil
		ifTrue: 
			[ ^ misspelled correctAgainstDictionary: Smalltalk continuedFrom: results ]
		ifFalse:
			[ ^ superclass possibleVariablesFor: misspelled continuedFrom: results ] ! !

!RedirectorMixin methodsFor: 'accessing' stamp: 'rww 1/27/2002 16:43'!
setName: aSymbol
	"Private - set the name of the class"
	name _ aSymbol. ! !

!RedirectorMixin methodsFor: 'class compatability' stamp: 'rww 1/27/2002 16:43'!
addSubclass: newClass ! !

!RedirectorMixin methodsFor: 'class compatability' stamp: 'rww 1/27/2002 16:43'!
declare: classVarString

	^false ! !

!RedirectorMixin methodsFor: 'class compatability' stamp: 'rww 1/27/2002 16:43'!
mixinSubclass: t contextClass: aContextClass instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat 
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class (the receiver)."
	^(ClassBuilder new)
		superclass: self
		mixinSubclass: t 
		contextClass: aContextClass 
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat
 ! !

!RedirectorMixin methodsFor: 'class compatability' stamp: 'rww 1/27/2002 16:44'!
obsolete
	"Change the receiver and all of its subclasses to an obsolete class."
	self == Object 
		ifTrue:[^self error:'Object is NOT obsolete'].
	name _ 'AnObsolete' , name.
	Object class instSize + 1 to: self class instSize do:
		[:i | self instVarAt: i put: nil]. "Store nil over class instVars."
	super obsolete.
 ! !

!RedirectorMixin methodsFor: 'class compatability' stamp: 'rww 1/27/2002 16:44'!
removeFromSystem
	"Forget the receiver from the Smalltalk global dictionary. Any existing 
	instances will refer to an obsolete version of the receiver."
	self removeFromSystem: true. ! !

!RedirectorMixin methodsFor: 'class compatability' stamp: 'rww 1/27/2002 16:44'!
removeFromSystem: logged
	"Forget the receiver from the Smalltalk global dictionary. Any existing 
	instances will refer to an obsolete version of the receiver."
	self superclass ifNotNil:[
		"If we have no superclass there's nothing to be remembered"
		self superclass addObsoleteSubclass: self].
	self environment removeClassFromSystem: self logged: logged.
	self obsolete ! !

!RedirectorMixin methodsFor: 'class compatability' stamp: 'rww 1/27/2002 16:44'!
removeSubclass: newClass ! !

!RedirectorMixin methodsFor: 'class compatability' stamp: 'rww 1/27/2002 16:44'!
sharing: poolString

	^false ! !

!RedirectorMixin methodsFor: 'class compatability' stamp: 'rww 1/27/2002 16:44'!
subclasses
	"Answer a Set containing the receiver's subclasses."

	^#() ! !

!RedirectorMixin methodsFor: 'class compatability' stamp: 'rww 1/27/2002 16:44'!
subclassesDo: aBlock 
 ! !

!RedirectorMixin methodsFor: 'class compatability' stamp: 'rww 1/27/2002 16:44'!
subclassesDoGently: aBlock 
 ! !

!RedirectorMixin methodsFor: 'fileIn/Out' stamp: 'rww 1/27/2002 16:44'!
contextClassString

	^self contextClass name asString ! !

!RedirectorMixin methodsFor: 'fileIn/Out' stamp: 'rww 1/27/2002 16:35'!
definitionST80
	"Answer a String that defines the receiver."

	| aStream path |
	aStream _ WriteStream on: (String new: 300).
	superclass == nil
		ifTrue: [aStream nextPutAll: 'ProtoObject']
		ifFalse: [path _ ''.
				self environment scopeFor: superclass name from: nil
						envtAndPathIfFound: [:envt :remotePath | path _ remotePath].
				aStream nextPutAll: path , superclass name].
	aStream nextPutAll: self kindOfSubclass;
			store: self name.
	aStream cr; tab; nextPutAll: 'contextClass: ';
			nextPutAll: self contextClassString.
	aStream cr; tab; nextPutAll: 'instanceVariableNames: ';
			store: self instanceVariablesString.
	aStream cr; tab; nextPutAll: 'classVariableNames: ';
			store: self classVariablesString.
	aStream cr; tab; nextPutAll: 'poolDictionaries: ';
			store: self sharedPoolsString.
	aStream cr; tab; nextPutAll: 'category: ';
			store: (SystemOrganization categoryOfElement: self name) asString.

	superclass ifNil: [ 
		aStream nextPutAll: '.'; cr.
		aStream nextPutAll: self name.
		aStream space; nextPutAll: 'superclass: nil'. ].

	^ aStream contents! !


!RedirectorMixin class methodsFor: 'test' stamp: 'rw 3/10/2002 17:04'!
baseMethodStrings

	^(OrderedCollection new)
		add: '== arg		^self target == arg';
		add: 'basicEquivalence: arg		^self target basicEquivalence: arg';
		add: 'class		^self target class';
		add: '~~ arg		^self target ~~ arg';
		add: 'isNil ^self target isNil';
		add: 'notNil ^self target notNil';
		add: 'ifNil: aBlock ^self target ifNil: aBlock';
		add: 'ifNotNil: aBlock ^self target ifNotNil: aBlock';
		add: 'hash ^self target hash';
		add: 'identityHash ^self target identityHash';
		add: 'yourself ^self redirector';

		add: 'inspect ^Inspector openOn: self redirector withEvalPane: true';
		add: 'printString 	^self target printString, ''(r)''';
		add: 'isKindOf: aBehavior  ^self target isKindOf: aBehavior';
		add: 'asText ^self printString asText';
		add: 'debugPrintString ^self target debugPrintString, ''(r)''';
		add: 'longPrintString ^self target longPrintString, ''(r)''';
		add: 'printStringLimitedTo: size ^(self target printStringLimitedTo: size), ''(r)''';
		add: 'printOn: stream  self target printOn: stream.   stream nextPutAll: ''(r)''';
		add: 'debugPrintOn: stream  self target debugPrintOn: stream.   stream nextPutAll: ''(r)''';
		add: 'defaultLabelForInspector    ^''redirected '', self target class name';


		add: 'isProxy		^ RedirectionManager isRedirectorObject: self redirector';
		add: 'isRedirector		^ RedirectionManager isRedirectorObject: self redirector';
		add: 'asOop	^ RedirectionManager asOopForRedirector: self redirector';
		add: 'clone	^ RedirectionManager cloneForRedirector: self redirector';
		add: 'nextInstance	^ RedirectionManager nextInstanceForRedirector: self redirector';
		add: 'nextObject	^ RedirectionManager nextObjectForRedirector: self redirector';
		yourself
! !

!RedirectorMixin class methodsFor: 'test' stamp: 'rww 1/26/2002 13:38'!
baseRedirectorClass

	"	RedirectorMixin baseRedirectorClass"
	^ self newNamed: 'BaseRedirectorMixin'
! !

!RedirectorMixin class methodsFor: 'test' stamp: 'rw 3/10/2002 17:09'!
newNamed: aName
	"	RedirectorMixin newNamed: 'TestMixin'"
	| mixin |
	mixin := ProtoObject
		mixinSubclass: aName
		contextClass: BehavioralRedirectorContext
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Redirector Mixins'.

	self baseMethodStrings do: 
		[:eachMethodString |
		mixin compile: eachMethodString].
	^ mixin! !


!RedirectorTestCase methodsFor: 'Proxy Creation' stamp: 'rw 1/5/2002 18:41'!
proxyOn: anObject

	^RedirectorContext on: anObject! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testAsOop

	"Check basic operation of a redirector"
	| proxy object |
	RedirectionManager enable.
	object := Object new.
	proxy := self proxyOn: object.

	self deny: (proxy asOop == object asOop).
! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testClass

	"Check basic operation of a redirector"
	| proxy object |
	RedirectionManager enable.
	object := Object new.
	proxy := self proxyOn: object.

	self assert: (proxy class = Object).
! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testClone

	"Check basic operation of a redirector"
	| proxy object |
	RedirectionManager enable.
	object := Object new.
	proxy := self proxyOn: object.

	self deny: (proxy clone == object clone).
	self assert: (proxy clone == object).
! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testEquivalenceProxyArgument

	"Check basic operation of a redirector"
	| proxy object |
	RedirectionManager enable.
	object := Object new.
	proxy := self proxyOn: object.

	self assert: (object == proxy).

! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testEquivalenceProxyReceiver

	"Check basic operation of a redirector"
	| proxy object |
	RedirectionManager enable.
	object := Object new.
	proxy := self proxyOn: object.

	self assert: (proxy == object).
! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testErrorWhenEnabledNoContext

	"Check for an error for creating an incorrect proxy"
	RedirectionManager enable.
	self should: [MessageRedirector new] raise: Error.
! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testHash

	"Check basic operation of a redirector"
	| proxy object |
	RedirectionManager enable.
	object := Object new.
	proxy := self proxyOn: object.

	self assert: (proxy hash = object hash).
! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testNextInstance

	"Check basic operation of a redirector"
	| proxy1 object1 proxy2 object2 nextInstance count |
	RedirectionManager enable.
	object1 := Object new.
	proxy1 := self proxyOn: object1.
	object2 := Object new.
	proxy2 := self proxyOn: object2.
	nextInstance := MessageRedirector someInstance.
	count := 0.
	[nextInstance isNil]
		whileFalse: 
			[count := count + 1.
			nextInstance := nextInstance nextInstance].
	self assert: (count > 0).! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testNextObject

	"Check basic operation of a redirector"
	| proxy1 object1 |
	RedirectionManager enable.
	object1 := Object new.
	proxy1 := self proxyOn: object1.
	self assert: (proxy1 nextObject notNil).

! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testNoErrorWhenEnabled

	"Check for an error for creating an incorrect proxy"
	| proxy |
	RedirectionManager enable.
	proxy := RedirectorContext on: Object new.
	self shouldnt: [proxy yourself] raise: Error.
! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testPrintString

	"Check basic operation of a redirector"
	| proxy object |
	RedirectionManager enable.
	object := Object new.
	proxy := self proxyOn: object.

	self assert: (proxy printString = 'an Object(r)').
! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:18'!
testProxyWhenDisabled

	"Check for an error for creating an incorrect proxy"
	RedirectionManager disable.
	self shouldnt: [RedirectorContext on: Object new] raise: Error.
! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testReturn

	"Check basic operation of a redirector"
	| proxy object |
	RedirectionManager enable.
	object := Object new.
	proxy := self proxyOn: object.

	self assert: (proxy beep printString = 'an Object(r)').
! !

!RedirectorTestCase methodsFor: 'Running' stamp: 'rw 3/10/2002 17:19'!
testSomeInstance

	"Check basic operation of a redirector"
	| proxy |
	RedirectionManager enable.
	proxy := self proxyOn: Object.
	self shouldnt: [proxy someInstance] raise: Error.
! !


!Semaphore methodsFor: 'mutual exclusion' stamp: 'rww 12/15/2001 16:56'!
critical: mutuallyExcludedBlock 
	"Evaluate mutuallyExcludedBlock only if the receiver is not currently in 
	the process of running the critical: message. If the receiver is, evaluate 
	mutuallyExcludedBlock after the other critical: message is finished."

	self wait.
	^[mutuallyExcludedBlock value] ensure: [self signal].
! !


!SystemDictionary methodsFor: 'special objects' stamp: 'rw 1/5/2002 18:35'!
recreateSpecialObjectsArray    "Smalltalk recreateSpecialObjectsArray"
	"The Special Objects Array is an array of object pointers used by the
	Smalltalk virtual machine.  Its contents are critical and unchecked,
	so don't even think of playing here unless you know what you are doing."
	| newArray |
	newArray _ Array new: 51.
	"Nil false and true get used throughout the interpreter"
	newArray at: 1 put: nil.
	newArray at: 2 put: false.
	newArray at: 3 put: true.
	"This association holds the active process (a ProcessScheduler)"
	newArray at: 4 put: (Smalltalk associationAt: #Processor).
	"Numerous classes below used for type checking and instantiation"
	newArray at: 5 put: Bitmap.
	newArray at: 6 put: SmallInteger.
	newArray at: 7 put: String.
	newArray at: 8 put: Array.
	newArray at: 9 put: Smalltalk. 
	newArray at: 10 put: Float.
	newArray at: 11 put: MethodContext.
	newArray at: 12 put: BlockContext.
	newArray at: 13 put: Point.
	newArray at: 14 put: LargePositiveInteger.
	newArray at: 15 put: Display.
	newArray at: 16 put: Message.
	newArray at: 17 put: CompiledMethod.
	newArray at: 18 put: (self specialObjectsArray at: 18)  "(low space Semaphore)".
	newArray at: 19 put: Semaphore.
	newArray at: 20 put: Character.
	newArray at: 21 put: #doesNotUnderstand:.
	newArray at: 22 put: #cannotReturn:.
	newArray at: 23 put: nil.  "*unused*"
	"An array of the 32 selectors that are compiled as special bytecodes,
	paired alternately with the number of arguments each takes."
	newArray at: 24 put: #(+ 1 - 1 < 1 > 1 <= 1 >= 1 = 1 ~= 1 * 1 / 1 \\ 1 @ 1 bitShift: 1 // 1 bitAnd: 1 bitOr: 1 at: 1 at:put: 2 size 0 next 0 nextPut: 1 atEnd 0 == 1 class 0 blockCopy: 1 value 0 value: 1 do: 1 new 0 new: 1 x 0 y 0 ).
	"An array of the 255 Characters in ascii order."
	newArray at: 25 put: ((0 to: 255) collect: [:ascii | Character value: ascii]).
	newArray at: 26 put: #mustBeBoolean.
	newArray at: 27 put: ByteArray.
	newArray at: 28 put: Process.
	"An array of up to 31 classes whose instances will have compact headers"
	newArray at: 29 put: self compactClassesArray.
	newArray at: 30 put: (self specialObjectsArray at: 30)   "(delay Semaphore)".
	newArray at: 31 put: (self specialObjectsArray at: 31)   "(user input Semaphore)".

	"Prototype instances that can be copied for fast initialization"
	newArray at: 32 put: (Float new: 2).
	newArray at: 33 put: (LargePositiveInteger new: 4).
	newArray at: 34 put: Point new.
	newArray at: 35 put: #cannotInterpret:.
	"Note: This must be fixed once we start using context prototypes"
	newArray at: 36 put: (self specialObjectsArray at: 36). 
						"(MethodContext new: CompiledMethod fullFrameSize)."
	newArray at: 37 put: nil.
	newArray at: 38 put: (self specialObjectsArray at: 38). 
						"(BlockContext new: CompiledMethod fullFrameSize)."

	newArray at: 39 put: Array new.  "array of objects referred to by external code"

	newArray at: 40 put: PseudoContext.
	newArray at: 41 put: TranslatedMethod.

	"finalization Semaphore"
	newArray at: 42 put: ((self specialObjectsArray at: 42) ifNil:[Semaphore new]).

	newArray at: 43 put: LargeNegativeInteger.

	"External objects for callout.
	Note: Written so that one can actually completely remove the FFI."
	newArray at: 44 put: (Smalltalk at: #ExternalAddress ifAbsent:[nil]).
	newArray at: 45 put: (Smalltalk at: #ExternalStructure ifAbsent:[nil]).
	newArray at: 46 put: (Smalltalk at: #ExternalData ifAbsent:[nil]).
	newArray at: 47 put: (Smalltalk at: #ExternalFunction ifAbsent:[nil]).
	newArray at: 48 put: (Smalltalk at: #ExternalLibrary ifAbsent:[nil]).

	newArray at: 49 put: #aboutToReturn:through:.

	newArray at: 50 put: (Smalltalk at: #MessageRedirector ifAbsent:[nil]).
	newArray at: 51 put: #redirectMessage:.

	"Now replace the interpreter's reference in one atomic operation"
	self specialObjectsArray become: newArray! !


!RedirectorTestCase reorganize!
('Proxy Creation' proxyOn:)
('Running' testAsOop testClass testClone testEquivalenceProxyArgument testEquivalenceProxyReceiver testErrorWhenEnabledNoContext testHash testNextInstance testNextObject testNoErrorWhenEnabled testPrintString testProxyWhenDisabled testReturn testSomeInstance)
!

RedirectorContext initialize!

!RedirectorContext class reorganize!
('accessing method dictionary' compiledMethodForRedirectionAt: compiledMethodForRedirectionAt:ifAbsent: includesSelectorForRedirection: lookupSelectorForRedirection: redirectionMethodDict redirectionMethodDict:)
('control' initialize new newOn: on:)
('message sending' redirectMessage:forContext:)
('compiling' addSelectorForRedirection:withMethod: baseMethodStrings compileForRedirection: compileForRedirection:withMarker: installBaseMethods)
('performance tests' secondsToRunEachOverCount:block: testTiming:creationBlock:)
!


!BehavioralRedirectorContext reorganize!
('message sending' behavior behavior: redirectMessage:)
!


!RedirectorContext reorganize!
('accessing' redirector target target:)
('message sending' becomeContext: redirectMessage:)
('initialization' initialize)
!


!RedirectionManager class reorganize!
('redirector mop' asOopForRedirector: becomeContext:forRedirector: cloneForRedirector: createRedirectorOnContext: isRedirectorObject: nextInstanceForRedirector: nextObjectForRedirector:)
('executing compiled methods' executeCompiledMethod:onReceiver: executeCompiledMethod:onReceiver:withArguments:)
('control' disable enable isEnabled)
('primitives' primAsOopForRedirector: primCloneForRedirector: primCreateRedirectorOnContext: primDisableRedirection primEnableRedirectionWithCompactClassIndex: primExecuteCompiledMethod:onReceiver: primExecuteCompiledMethod:onReceiver:withArguments: primIsRedirectionEnabled primIsRedirectorObject: primNextInstanceForRedirector: primNextObjectForRedirector: primSwitchRedirector:toContext:)
!


!Interpreter reorganize!
('initialization' initializeInterpreter: loadInitialContext moduleUnloaded:)
('utilities' areIntegers:and: arrayValueOf: assertClassOf:is: booleanCheat: booleanValueOf: checkedIntegerValueOf: externalizeIPandSP fetchArray:ofObject: fetchFloat:ofObject: fetchInteger:ofObject: fetchIntegerOrTruncFloat:ofObject: floatValueOf: internalizeIPandSP loadFloatOrIntFrom: makePointwithxValue:yValue: quickFetchInteger:ofObject: signExtend16: sizeOfSTArrayFromCPrimitive: storeInteger:ofObject:withValue: transfer:from:to: transfer:fromIndex:ofObject:toIndex:ofObject:)
('object memory support' mapInterpreterOops markAndTraceInterpreterOops postGCAction preGCAction:)
('compiled methods' argumentCountOf: headerOf: isHandlerMarked: isUnwindMarked: literal: literal:ofMethod: literalCountOf: literalCountOfHeader: methodClassOf: primitiveIndexOf: primitiveNewMethod)
('contexts' argumentCountOfBlock: caller context:hasSender: fetchContextRegisters: fetchStackPointerOf: internalFetchContextRegisters: internalNewActiveContext: internalPop: internalPop:thenPush: internalPush: internalStackTop internalStackValue: internalStoreContextRegisters: isContext:header: isContextHeader: isMethodContextHeader: newActiveContext: pop2AndPushIntegerIfOK: pop: pop:thenPush: popInteger popPos32BitInteger popStack primitiveFindHandlerContext primitiveFindNextUnwindContext primitiveMarkHandlerMethod primitiveMarkUnwindMethod primitiveTerminateTo primitiveValueUninterruptably push: pushBool: pushInteger: sender stackFloatValue: stackIntegerValue: stackObjectValue: stackPointerIndex stackTop stackValue: storeContextRegisters: storeInstructionPointerValue:inContext: storeStackPointerValue:inContext: temporary: unPop:)
('object format' fixedFieldsOf:format:length: formatOfClass: nonWeakFieldsOf:)
('redirectors' dumpOop: isRedirectorObject: primitiveAsOopForRedirector primitiveCloneForRedirector primitiveCreateRedirectorOnContext primitiveDisableRedirection primitiveEnableRedirectionWithCompactClassIndex primitiveExecuteCompiledMethodOnReceiver primitiveExecuteCompiledMethodOnReceiverWithArgs primitiveIsRedirectionEnabled primitiveIsRedirectorObject primitiveNextInstanceForRedirector primitiveNextObjectForRedirector primitiveSwitchRedirectorToContext redirectionSend setupRedirectionMethodFor:)
('message sending' activateNewMethod argCount createActualMessageTo: executeNewMethod findNewMethodInClass: internalActivateNewMethod internalExecuteNewMethod internalFindNewMethod lookupMethodInClass: lookupMethodInDictionary: normalSend specialSelector: superclassOf: superclassSend)
('method lookup cache' addNewMethodToCache flushMethodCache flushMethodCacheFrom:to: lookupInMethodCacheSel:class: rewriteMethodCacheSel:class:primIndex:)
('interpreter shell' fetchByte fetchNextBytecode getCurrentBytecode interpret unknownBytecode)
('stack bytecodes' duplicateTopBytecode experimentalBytecode extendedPushBytecode extendedStoreAndPopBytecode extendedStoreBytecode popStackBytecode pushActiveContextBytecode pushConstantFalseBytecode pushConstantMinusOneBytecode pushConstantNilBytecode pushConstantOneBytecode pushConstantTrueBytecode pushConstantTwoBytecode pushConstantZeroBytecode pushLiteralConstant: pushLiteralConstantBytecode pushLiteralVariable: pushLiteralVariableBytecode pushReceiverBytecode pushReceiverVariable: pushReceiverVariableBytecode pushTemporaryVariable: pushTemporaryVariableBytecode storeAndPopReceiverVariableBytecode storeAndPopTemporaryVariableBytecode)
('jump bytecodes' jump: jumplfFalseBy: jumplfTrueBy: longJumpIfFalse longJumpIfTrue longUnconditionalJump shortConditionalJump shortUnconditionalJump)
('send bytecodes' doubleExtendedDoAnythingBytecode secondExtendedSendBytecode sendLiteralSelectorBytecode singleExtendedSendBytecode singleExtendedSuperBytecode)
('return bytecodes' internalAboutToReturn:through: internalCannotReturn: returnFalse returnNil returnReceiver returnTopFromBlock returnTopFromMethod returnTrue returnValue:to:)
('common selector sends' bytecodePrimAdd bytecodePrimAt bytecodePrimAtEnd bytecodePrimAtPut bytecodePrimBitAnd bytecodePrimBitOr bytecodePrimBitShift bytecodePrimBlockCopy bytecodePrimClass bytecodePrimDiv bytecodePrimDivide bytecodePrimDo bytecodePrimEqual bytecodePrimEquivalent bytecodePrimGreaterOrEqual bytecodePrimGreaterThan bytecodePrimLessOrEqual bytecodePrimLessThan bytecodePrimMakePoint bytecodePrimMod bytecodePrimMultiply bytecodePrimNew bytecodePrimNewWithArg bytecodePrimNext bytecodePrimNextPut bytecodePrimNotEqual bytecodePrimPointX bytecodePrimPointY bytecodePrimSize bytecodePrimSubtract bytecodePrimValue bytecodePrimValueWithArg primitiveDisablePowerManager)
('primitive support' failed positive32BitIntegerFor: positive32BitValueOf: positive64BitIntegerFor: positive64BitValueOf: primIndex primitiveFail primitiveResponse signed32BitIntegerFor: signed32BitValueOf: signed64BitIntegerFor: signed64BitValueOf: success:)
('arithmetic primitives' checkBooleanResult: checkIntegerResult: compare31or32Bits:equal: doPrimitiveDiv:by: doPrimitiveMod:by: primitiveAdd primitiveBitAnd primitiveBitOr primitiveBitShift primitiveBitXor primitiveDiv primitiveDivide primitiveEqual primitiveGreaterOrEqual primitiveGreaterThan primitiveLessOrEqual primitiveLessThan primitiveMakePoint primitiveMod primitiveMultiply primitiveNotEqual primitiveQuo primitiveSubtract)
('float primitives' popFloat primitiveArctan primitiveAsFloat primitiveExp primitiveExponent primitiveFloatAdd primitiveFloatAdd:toArg: primitiveFloatDivide primitiveFloatDivide:byArg: primitiveFloatEqual primitiveFloatEqual:toArg: primitiveFloatGreater:thanArg: primitiveFloatGreaterOrEqual primitiveFloatGreaterThan primitiveFloatLess:thanArg: primitiveFloatLessOrEqual primitiveFloatLessThan primitiveFloatMultiply primitiveFloatMultiply:byArg: primitiveFloatNotEqual primitiveFloatSubtract primitiveFloatSubtract:fromArg: primitiveFractionalPart primitiveLogN primitiveSine primitiveSquareRoot primitiveTimesTwoPower primitiveTruncated pushFloat:)
('array and stream primitives' asciiOfCharacter: byteLengthOf: characterForAscii: commonAt: commonAtPut: commonVariable:at:cacheIndex: commonVariable:at:put:cacheIndex: commonVariableInternal:at:cacheIndex: install:inAtCache:at:string: lengthOf: lengthOf:baseHeader:format: okArrayClass: okStreamArrayClass: primitiveAt primitiveAtEnd primitiveAtPut primitiveNext primitiveNextPut primitiveSize primitiveStringAt primitiveStringAtPut primitiveStringReplace stObject:at: stObject:at:put: stSizeOf: subscript:with:format: subscript:with:storing:format:)
('object access primitives' primitiveArrayBecome primitiveArrayBecomeOneWay primitiveAsOop primitiveChangeClass primitiveClass primitiveClone primitiveEquivalent primitiveInstVarAt primitiveInstVarAtPut primitiveNew primitiveNewWithArg primitiveNextInstance primitiveNextObject primitiveObjectAt primitiveObjectAtPut primitiveObjectPointsTo primitivePointX primitivePointY primitiveSomeInstance primitiveSomeObject primitiveStoreStackp sufficientSpaceToInstantiate:indexableSize:)
('control primitives' internalPrimitiveValue primitiveBlockCopy primitiveDoPrimitiveWithArgs primitivePerform primitivePerformAt: primitivePerformInSuperclass primitivePerformWithArgs primitiveValue primitiveValueWithArgs)
('processes' addLastLink:toList: checkForInterrupts internalQuickCheckForInterrupts isEmptyList: primitiveResume primitiveSignal primitiveSuspend primitiveWait putToSleep: quickCheckForInterrupts removeFirstLinkOfList: resume: schedulerPointer signalExternalSemaphores signalFinalization: signalSemaphoreWithIndex: synchronousSignal: transferTo: wakeHighestPriority)
('I/O primitives' displayBitsOf:Left:Top:Right:Bottom: fullDisplayUpdate primitiveBeCursor primitiveBeDisplay primitiveBeep primitiveDeferDisplayUpdates primitiveForceDisplayUpdate primitiveGetNextEvent primitiveInputSemaphore primitiveInputWord primitiveInterruptSemaphore primitiveKbdNext primitiveKbdPeek primitiveMouseButtons primitiveMousePoint primitiveScreenDepth primitiveScreenSize primitiveSetDisplayMode primitiveSetFullScreen primitiveSetInterruptKey primitiveShowDisplayRect primitiveTestDisplayDepth reverseDisplayFrom:to: showDisplayBits:Left:Top:Right:Bottom:)
('file primitives')
('memory space primitives' primitiveBytesLeft primitiveFullGC primitiveIncrementalGC primitiveLowSpaceSemaphore primitiveSignalAtBytesLeft)
('socket primitives')
('resolver primitives')
('sound primitives' primitiveConstantFill primitiveIntegerAt primitiveIntegerAtPut primitiveShortAt primitiveShortAtPut)
('other primitives' primitiveCalloutToFFI primitiveClipboardText primitiveExitToDebugger primitiveExternalCall primitiveFlushCache primitiveFlushCacheByMethod primitiveFlushCacheSelective primitiveFlushExternalPrimitives primitiveFormPrint primitiveGetAttribute primitiveGetTabletParameters primitiveImageName primitiveListBuiltinModule primitiveListExternalModule primitiveMillisecondClock primitiveNoop primitiveObsoleteIndexedPrimitive primitiveQuit primitiveRelinquishProcessor primitiveScanCharacters primitiveSecondsClock primitiveSignalAtMilliseconds primitiveSnapshot primitiveSnapshotEmbedded primitiveSpecialObjectsOop primitiveUnloadModule primitiveVMParameter primitiveVMPath)
('debug printing' cr print: printChar: printNum:)
('debug support' allAccessibleObjectsOkay balancedStack:afterPrimitive:withArgs: findClassOfMethod:forReceiver: findSelectorOfMethod:forReceiver: okayActiveProcessStack okayFields: okayInterpreterObjects okayOop: oopHasOkayClass: printAllStacks printCallStack printCallStackOf: printNameOfClass:count: printStringOf: printUnbalancedStack: printUnbalancedStackFromNamedPrimitive verifyCleanHeaders)
('image save/restore' byteSwapByteObjects byteSwapByteObjectsFrom:to: byteSwapped: checkImageVersionFrom:startingAt: cleanUpContexts getLongFromFile:swap: imageFormatVersion putLong:toFile: readImageFromFile:HeapSize:StartingAt: readableFormat: reverseBytesFrom:to: reverseBytesInImage writeImageFile: writeImageFileEmbedded: writeImageFileIO:)
('quick primitives' primitiveInstVarsPutFromStack primitiveLoadInstVar primitivePushFalse primitivePushMinusOne primitivePushNil primitivePushOne primitivePushSelf primitivePushTrue primitivePushTwo primitivePushZero)
('serial port primitives')
('midi primitives')
('async file primitives')
('plugin support' addToExternalPrimitiveTable: byteSizeOf: classNameOf:Is: findObsoleteNamedPrimitive:length: firstFixedField: firstIndexableField: floatObjectOf: flushExternalPrimitiveOf: flushExternalPrimitiveTable flushExternalPrimitives flushObsoleteIndexedPrimitives includesBehavior:ThatOf: is:KindOf: is:MemberOf: isFloatObject: isIndexable: methodArgumentCount methodPrimitiveIndex primitiveMethod slotSizeOf:)
('compiler support' compilerCreateActualMessage:storingArgs: compilerFlushCache: compilerFlushCacheHook: compilerMapFrom:to: compilerMapHookFrom:to: compilerMark compilerMarkHook compilerPostGC compilerPostGCHook compilerPostSnapshot compilerPostSnapshotHook compilerPreGC: compilerPreGCHook: compilerPreSnapshot compilerPreSnapshotHook compilerProcessChange compilerProcessChange:to: compilerProcessChangeHook compilerTranslateMethod compilerTranslateMethodHook disableCompiler enableCompiler initCompilerHooks nullCompilerHook setCompilerInitialized:)
('image segment in/out' copyObj:toSegment:addr:stopAt:saveOopAt:headerAt: forward:to:savingOopAt:andHeaderAt: imageSegmentVersion oopHasOKclass: primitiveFailAfterCleanup: primitiveLoadImageSegment primitiveStoreImageSegment restoreHeadersFrom:to:from:and:to:from:)
('bitblt support' copyBits copyBitsFrom:to:at: loadBitBltFrom:)
!

Object subclass: #ObjectMemory
	instanceVariableNames: 'memory youngStart endOfMemory memoryLimit nilObj falseObj trueObj specialObjectsOop rootTable rootTableCount child field parentField freeBlock lastHash allocationCount lowSpaceThreshold signalLowSpace compStart compEnd fwdTableNext fwdTableLast remapBuffer remapBufferCount allocationsBetweenGCs tenuringThreshold statFullGCs statFullGCMSecs statIncrGCs statIncrGCMSecs statTenures statRootTableOverflows freeContexts freeLargeContexts interruptCheckCounter displayBits totalObjectCount shrinkThreshold growHeadroom '
	classVariableNames: 'AllButHashBits AllButMarkBit AllButMarkBitAndTypeMask AllButRootBit AllButTypeMask BaseHeaderSize BlockContextProto CharacterTable ClassArray ClassBitmap ClassBlockContext ClassByteArray ClassCharacter ClassCompiledMethod ClassExternalAddress ClassExternalData ClassExternalFunction ClassExternalLibrary ClassExternalStructure ClassFloat ClassInteger ClassLargeNegativeInteger ClassLargePositiveInteger ClassMessage ClassMethodContext ClassPoint ClassProcess ClassPseudoContext ClassRedirector ClassSemaphore ClassString ClassTranslatedMethod CompactClassMask CompactClasses ConstMinusOne ConstOne ConstTwo ConstZero CtxtTempFrameStart DoAssertionChecks DoBalanceChecks Done ExternalObjectsArray FalseObject FloatProto GCTopMarker HashBits HashBitsOffset HeaderTypeClass HeaderTypeFree HeaderTypeGC HeaderTypeShort HeaderTypeSizeAndClass LargeContextBit LargeContextSize MarkBit MethodContextProto NilContext NilObject RemapBufferSize RootBit RootTableSize SchedulerAssociation SelectorAboutToReturn SelectorCannotInterpret SelectorCannotReturn SelectorDoesNotUnderstand SelectorMustBeBoolean SelectorRedirectMessage SizeMask SmallContextSize SpecialSelectors StackStart StartField StartObj TheDisplay TheFinalizationSemaphore TheInputSemaphore TheInterruptSemaphore TheLowSpaceSemaphore TheTimerSemaphore TrueObject TypeMask Upward '
	poolDictionaries: ''
	category: 'VMConstruction-Interpreter'!
