'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 14 July 2002 at 2:15:21 pm'!
"Change Set:		SharedQ-shift-contents-fix
Date:			24 July 2001
Author:			rww

This changeset fixes two methods which reshuffle the contents without niling out unused slots.  This presents a situation where objects can not be garbaged collected, since an old Q slot holds the Oop.  Also, a nextWaitTimeoutMS: method is added, which is needed to not block forever.  This way we can recover if the producer is frotzed"!


!SharedQueue methodsFor: 'accessing' stamp: 'rww 1/13/2002 12:45'!
flush
	"Throw out all pending contents"
	accessProtect critical: [
		readPosition _ 1.
		writePosition _ 1.
		readPosition >= writePosition ifTrue: [readSynch initSignals].
		contentsArray 
			from: writePosition
			to: contentsArray size 
			put: nil].! !

!SharedQueue methodsFor: 'accessing' stamp: 'rww 8/26/2001 23:44'!
nextNoWait
	"Answer the object that was sent through the  
	
	receiver first and has not  
	
	yet been received by anyone. If no object has  
	
	been sent, return nil."
	^ self nextOrNil! !

!SharedQueue methodsFor: 'accessing' stamp: 'rww 1/13/2002 12:47'!
nextTimeoutMSecs: milliSeconds 
	"Answer the object that was sent through the  
	receiver first and has not  
	yet been received by anyone. If no object has 
	been sent, suspend the  
	requesting process until one is."

	| value |
	readSynch waitTimeoutMSecs: milliSeconds.
	accessProtect
		critical: 
			[readPosition = writePosition
				ifTrue: 
					[value := nil]
				ifFalse: 
					[value := contentsArray at: readPosition.
					contentsArray at: readPosition put: nil.
					readPosition := readPosition + 1]].
	^ value! !

!SharedQueue methodsFor: 'accessing' stamp: 'rww 1/13/2002 12:49'!
peek
	"Answer the object that was sent through the receiver first and has not 
	yet been received by anyone but do not remove it from the receiver. If 
	no object has been sent, suspend the requesting process until one is."

	| value |
	accessProtect
		critical: 
			[readPosition >= writePosition
				ifTrue: 
					[readPosition _ 1.
					writePosition _ 1.
					value _ nil]
				ifFalse: 
					[value _ contentsArray at: readPosition].
			readPosition >= writePosition ifTrue: [readSynch initSignals]].
	^value! !

!SharedQueue methodsFor: 'private' stamp: 'rww 1/13/2002 12:49'!
makeRoomAtEnd
	| contentsSize |
	readPosition = 1
		ifTrue: 
			[contentsArray _ contentsArray , (Array new: 10)]
		ifFalse: 
			[contentsSize _ writePosition - readPosition.

			contentsArray
				replaceFrom: 1
				to: contentsSize
				with: contentsArray
				startingAt: readPosition.
			readPosition _ 1.
			writePosition _ contentsSize + 1.
			contentsArray 
				from: writePosition
				to: contentsArray size 
				put: nil]! !

