'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 14 July 2002 at 2:20:04 pm'!
EventManager subclass: #DispatchQueue
	instanceVariableNames: 'queue stepper state '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Async'!

!DispatchQueue commentStamp: '<historical>' prior: 0!
"Test code"

	| queue |
	queue := DispatchQueue new.
	queue foreground.
	[10 timesRepeat: [queue asyncSend: #value to: [Smalltalk beep]]] fork.
	queue

	queue when: #event send: #beep to: Smalltalk.
	queue when: #dispatchQueueClosed send: #value to: [queue release. Transcript cr; show: 'queue closed event'].
	queue enqueue: [queue triggerEvent: #event].
(Delay forMilliseconds: 10) wait.
	queue close.


Smalltalk garbageCollect.
DispatchQueue withAllSubclasses asOrderedCollection collect: [:each | each instanceCount].

DispatchQueue withAllSubclassesDo: 
	[:eachClass | eachClass allInstancesDo: 
		[:eachInst | eachInst inspect]].




Smalltalk garbageCollect


{QueuedFuture allInstances. DispatchQueue allInstances. DispatchQueueTest allInstances. AsyncMessageSecretary allInstances. EventTupleSpace allInstances} 
	inject: false 
	into: [:stillGarbage :eachColl | stillGarbage | eachColl isEmpty not]


QueuedFuture allInstances do: [:e | e release].
((DispatchQueue allInstances select: [:e | e isForeground])
	select: [:each | each queue isKindOf: SharedQueue]) do: [:q | q close].
((DispatchQueue allInstances select: [:e | e isBackground])
	select: [:each | each queue isKindOf: SharedQueue]) do: [:q | q close].!

Object subclass: #DispatchSecretary
	instanceVariableNames: 'queue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Async'!

!DispatchSecretary commentStamp: '<historical>' prior: 0!
| a1 a2 |
a1 := DispatchSecretary new.
a2 := DispatchSecretary new.
a1 foreground.
a2 background.


a1 
	asyncSend: #value 
	to: [ Transcript cr; show: 'hello']  
	agent: a2 
	onResult: [:r | Smalltalk beep] 
	ifError:  [:err |  Smalltalk beep].
[	(Delay forSeconds: 1) wait.
	a1 close.
	a2 close] fork.!

Object subclass: #FutureMessage
	instanceVariableNames: 'receiver message future '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Async'!
Object subclass: #PublishEventMessage
	instanceVariableNames: 'publisher event arguments '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Async'!
Object subclass: #QueuedFuture
	instanceVariableNames: 'myEvents dispatchQ '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Async'!
Object subclass: #SharedPriorityQueue
	instanceVariableNames: 'contents accessProtect readSync '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Queues-Priority'!
SharedPriorityQueue subclass: #FixedSizeSharedPriorityQueue
	instanceVariableNames: 'writeSync '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Queues-Priority'!
Object subclass: #Task
	instanceVariableNames: 'process taskAction shouldRescheduleAction stopping stopSemaphore priority '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Async'!

!Task commentStamp: '<historical>' prior: 0!
This class models an activity. This activity is presumed to occur some number of milliseconds in the future. In addition, it may be a recurring task. The task is created in a dormant state. The message #start must be sent to an instance before it will schedule itself for execution. At any point, one may deschedule a task by sending the message #stop.!


!Object methodsFor: 'async sending' stamp: 'rw 4/7/2002 19:28'!
future

	^ self secretary createFuture.
! !

!Object methodsFor: 'async sending' stamp: 'rw 4/7/2002 19:15'!
futureMessageSendClass

	^FutureMessage! !

!Object methodsFor: 'async sending' stamp: 'rw 4/7/2002 18:43'!
secretary
 
	^Smalltalk at: #GlobalSecretary ifAbsentPut: (DispatchSecretary dispatchForeground)! !

!Object methodsFor: 'async sending' stamp: 'rw 5/4/2002 00:21'!
sendFutureMessage: msgSend

	self secretary sendMessage: msgSend.
! !


!DispatchQueue methodsFor: 'testing' stamp: 'rw 2/16/2002 15:43'!
isBackground
	^ state = self backgroundState! !

!DispatchQueue methodsFor: 'testing' stamp: 'rw 2/20/2002 01:23'!
isEmpty

	^ queue isEmpty! !

!DispatchQueue methodsFor: 'testing' stamp: 'rw 2/16/2002 15:43'!
isForeground
	^ state = self foregroundState! !

!DispatchQueue methodsFor: 'testing' stamp: 'rw 2/16/2002 15:44'!
isRunning
	^ state ~= self suspendedState! !

!DispatchQueue methodsFor: 'testing' stamp: 'rw 2/20/2002 01:23'!
notEmpty

	^ self isEmpty not! !

!DispatchQueue methodsFor: 'testing' stamp: 'rw 2/16/2002 18:56'!
size

	^ queue isNil
		ifTrue: [0]
		ifFalse: [queue size]
! !

!DispatchQueue methodsFor: 'accessing' stamp: 'rw 2/16/2002 18:48'!
nextPut: anItem

	queue nextPut: anItem
! !

!DispatchQueue methodsFor: 'accessing' stamp: 'rw 2/20/2002 01:24'!
priority

	^stepper 
		ifNil: [-1] 
		ifNotNil: [stepper priority].! !

!DispatchQueue methodsFor: 'accessing' stamp: 'rw 2/20/2002 01:24'!
priority: aPriority

	stepper ifNotNil: [stepper priority: aPriority].
! !

!DispatchQueue methodsFor: 'private' stamp: 'rw 2/16/2002 18:56'!
backgroundState

	^#background! !

!DispatchQueue methodsFor: 'private' stamp: 'rw 2/16/2002 18:47'!
dispatch
	| item |
	item _ queue nextTimeoutMSecs: 100.
	item value! !

!DispatchQueue methodsFor: 'private' stamp: 'rw 2/16/2002 18:56'!
foregroundState

	^#foreground! !

!DispatchQueue methodsFor: 'private' stamp: 'rw 2/16/2002 18:55'!
initialize

	state := self suspendedState.! !

!DispatchQueue methodsFor: 'private' stamp: 'rw 2/20/2002 01:24'!
printOn: aStream 

	super printOn: aStream.
	aStream nextPutAll: ' ('.
	aStream nextPutAll: ' pending: ' , self size printString.
	aStream nextPutAll: ' priority: ', self priority printString. 
	aStream nextPutAll: ')'! !

!DispatchQueue methodsFor: 'private' stamp: 'rw 2/16/2002 18:55'!
suspendedState

	^#suspended! !

!DispatchQueue methodsFor: 'control' stamp: 'rw 2/16/2002 18:51'!
background
	self suspend.
	state := self backgroundState.
	queue := SharedQueue new.
	stepper _ Task taskAction: (MessageSend receiver: self selector: #dispatch).
	stepper start.
! !

!DispatchQueue methodsFor: 'control' stamp: 'rw 2/16/2002 18:51'!
close
	"We need to do this after all events have been flushed, so:  
	
		stop enqueuing  
	
		when the last event has been processed, suspend the stepper"

	self flush.
	self suspend.! !

!DispatchQueue methodsFor: 'control' stamp: 'rw 2/16/2002 18:51'!
flush

	[self isEmpty not] whileTrue: [queue nextNoWait].
! !

!DispatchQueue methodsFor: 'control' stamp: 'rw 2/16/2002 18:51'!
foreground
	| oldQueue |
	self suspend.
	state := self foregroundState.
	oldQueue := queue.
	queue := WorldState deferredUIMessages.
	oldQueue isNil ifFalse: [[oldQueue isEmpty] whileFalse: [queue nextPut: oldQueue nextOrNil]].! !

!DispatchQueue methodsFor: 'control' stamp: 'rw 2/16/2002 18:51'!
suspend

	| theStepper |
	state := self suspendedState.
	stepper ifNotNil: 
		[theStepper := stepper.
		stepper := nil.
		theStepper stop].

! !


!DispatchSecretary methodsFor: 'accessing' stamp: 'rww 1/15/2001 05:44'!
priority

	^queue priority.! !

!DispatchSecretary methodsFor: 'accessing' stamp: 'rww 1/15/2001 05:44'!
priority: aPriority

	^queue priority: aPriority.! !

!DispatchSecretary methodsFor: 'control' stamp: 'rww 1/5/2001 06:46'!
background

	queue background.
! !

!DispatchSecretary methodsFor: 'control' stamp: 'rww 9/26/2001 09:53'!
close
	queue close.
	self releaseActionMap.! !

!DispatchSecretary methodsFor: 'control' stamp: 'rww 1/5/2001 06:46'!
foreground

	queue foreground.
! !

!DispatchSecretary methodsFor: 'control' stamp: 'rww 1/5/2001 06:46'!
suspend

	queue suspend.
! !

!DispatchSecretary methodsFor: 'futures' stamp: 'rww 7/8/2001 21:06'!
createFuture

	^ QueuedFuture onQueue: queue.
! !

!DispatchSecretary methodsFor: 'initialization' stamp: 'rw 4/7/2002 19:58'!
initialize
	queue _ DispatchQueue new! !

!DispatchSecretary methodsFor: 'initialization' stamp: 'rww 1/15/2001 05:53'!
printOn: aStream 

	super printOn: aStream.
	aStream nextPutAll: ' ('.
	aStream nextPutAll: ' pending: ' , queue size printString.
	aStream nextPutAll: ' priority: ', self priority printString. 
	aStream nextPutAll: ')'! !

!DispatchSecretary methodsFor: 'sending' stamp: 'rw 5/4/2002 00:15'!
sendMessage: msgSend

	queue nextPut: msgSend! !


!DispatchSecretary class methodsFor: 'instance creation' stamp: 'rww 1/14/2001 02:19'!
dispatchBackground

	^self new 
		background;
		yourself.


! !

!DispatchSecretary class methodsFor: 'instance creation' stamp: 'rww 1/14/2001 02:19'!
dispatchForeground

	^self new 
		foreground;
		yourself.


! !

!DispatchSecretary class methodsFor: 'instance creation' stamp: 'rww 1/14/2001 02:19'!
new

	^super new initialize

! !


!FutureMessage methodsFor: 'as yet unclassified' stamp: 'rw 3/23/2002 18:13'!
future

	^future! !

!FutureMessage methodsFor: 'as yet unclassified' stamp: 'rw 3/23/2002 18:13'!
future: aFuture

	future := aFuture! !

!FutureMessage methodsFor: 'as yet unclassified' stamp: 'rw 4/7/2002 17:29'!
message

	^ message! !

!FutureMessage methodsFor: 'as yet unclassified' stamp: 'rw 4/7/2002 17:34'!
message: aMessage

	aMessage lookupClass: nil.
	message := aMessage! !

!FutureMessage methodsFor: 'as yet unclassified' stamp: 'rw 4/7/2002 17:29'!
receiver

	^ receiver! !

!FutureMessage methodsFor: 'as yet unclassified' stamp: 'rw 4/7/2002 17:29'!
receiver: aReceiver

	receiver := aReceiver! !

!FutureMessage methodsFor: 'as yet unclassified' stamp: 'rw 4/7/2002 17:54'!
value

	[self future value: (self message sentTo: self receiver)]
		on: Exception
		do: [:ex | self future exception: ex].
	^self future.! !


!FutureMessage class methodsFor: 'as yet unclassified' stamp: 'rw 4/7/2002 17:31'!
receiver: anObject message: aMessage future: aFuture
	^ self new
		receiver: anObject;
		message: aMessage;
		future: aFuture; 
		yourself! !


!Message methodsFor: 'accessing' stamp: 'rw 4/7/2002 17:34'!
lookupClass

	^lookupClass! !

!Message methodsFor: 'accessing' stamp: 'rw 4/7/2002 17:34'!
lookupClass: aClass

	lookupClass := aClass.! !


!PublishEventMessage methodsFor: 'accessing' stamp: 'rw 4/7/2002 20:11'!
arguments

	^ arguments
! !

!PublishEventMessage methodsFor: 'accessing' stamp: 'rw 4/7/2002 20:15'!
arguments: argArray

	arguments := argArray
! !

!PublishEventMessage methodsFor: 'accessing' stamp: 'rw 4/7/2002 20:11'!
event

	^ event! !

!PublishEventMessage methodsFor: 'accessing' stamp: 'rw 4/7/2002 20:16'!
event: anEvent

	event := anEvent! !

!PublishEventMessage methodsFor: 'accessing' stamp: 'rw 4/7/2002 20:17'!
publisher

	^ publisher! !

!PublishEventMessage methodsFor: 'accessing' stamp: 'rw 4/7/2002 20:17'!
publisher: aPublisher

	publisher := aPublisher! !

!PublishEventMessage methodsFor: 'evaluating' stamp: 'rw 4/7/2002 20:18'!
value

	[self publisher triggerEvent: self event withArguments: self arguments]
		on: Exception
		do: [:ex | ].
! !


!PublishEventMessage class methodsFor: 'as yet unclassified' stamp: 'rw 4/7/2002 20:19'!
publisher: anEventPublisher event: anEvent arguments: argArray

	^ self new
		publisher: anEventPublisher;
		event: anEvent;
		arguments: argArray; 
		yourself! !


!QueuedFuture methodsFor: 'initialization' stamp: 'rw 2/17/2002 02:26'!
actionMap

    ^myEvents == nil
        ifTrue: [self createActionMap]
        ifFalse: [myEvents]! !

!QueuedFuture methodsFor: 'initialization' stamp: 'rww 1/14/2001 02:14'!
bindQueue: aQueue

	dispatchQ := aQueue.

! !

!QueuedFuture methodsFor: 'initialization' stamp: 'rw 2/17/2002 02:27'!
copy

	| answer |
	answer := super copy.
	answer release.
	^answer! !

!QueuedFuture methodsFor: 'initialization' stamp: 'rw 2/17/2002 02:26'!
releaseActionMap

    myEvents := nil! !

!QueuedFuture methodsFor: 'initialization' stamp: 'rw 2/17/2002 02:27'!
updateableActionMap

    myEvents == nil
        ifTrue: [myEvents := self createActionMap].
    ^myEvents! !

!QueuedFuture methodsFor: 'producer' stamp: 'rw 4/7/2002 20:24'!
exception: anException

	dispatchQ nextPut: (PublishEventMessage 
		publisher: self 
		event: #exception: 
		arguments: {anException}).
! !

!QueuedFuture methodsFor: 'producer' stamp: 'rw 4/7/2002 20:25'!
value: aValue

	dispatchQ nextPut: (PublishEventMessage 
		publisher: self 
		event: #result: 
		arguments: {aValue}).
! !

!QueuedFuture methodsFor: 'accessing' stamp: 'rw 2/17/2002 02:25'!
myEvents

	^myEvents! !

!QueuedFuture methodsFor: 'accessing' stamp: 'rw 2/17/2002 02:25'!
myEvents: events

	myEvents := events! !


!QueuedFuture class methodsFor: 'instance creation' stamp: 'rww 7/8/2001 21:29'!
new

	self shouldNotImplement! !

!QueuedFuture class methodsFor: 'instance creation' stamp: 'rww 7/8/2001 21:29'!
onQueue: aQueue

	^ self basicNew
		bindQueue: aQueue;
		yourself
! !


!SharedPriorityQueue methodsFor: 'access operations' stamp: 'rww 7/29/2000 22:59'!
critical: aBlock
	^ accessProtect critical: aBlock
! !

!SharedPriorityQueue methodsFor: 'access operations' stamp: 'rww 7/29/2000 23:52'!
flush
	self critical: [contents size timesRepeat: [contents removeFirst]].! !

!SharedPriorityQueue methodsFor: 'access operations' stamp: 'rww 7/29/2000 22:58'!
isEmpty
	^ self critical: [contents isEmpty]! !

!SharedPriorityQueue methodsFor: 'access operations' stamp: 'rww 7/29/2000 23:02'!
nextNoWait
	^ self critical: [contents isEmpty
			ifTrue: [nil]
			ifFalse: [contents removeFirst]].
! !

!SharedPriorityQueue methodsFor: 'access operations' stamp: 'rww 7/29/2000 23:00'!
nextPut: aValue
	self critical: [contents add: aValue].
	readSync signal.
	^ aValue
! !

!SharedPriorityQueue methodsFor: 'access operations' stamp: 'rww 7/29/2000 23:03'!
peek
	^ self critical: [contents isEmpty
		ifTrue: [nil]
		ifFalse: [contents first]]
! !

!SharedPriorityQueue methodsFor: 'access operations' stamp: 'rww 7/29/2000 22:57'!
size
	^ self critical: [contents size]! !

!SharedPriorityQueue methodsFor: 'access operations' stamp: 'rww 7/29/2000 23:03'!
sortBlock: aBlock
	self critical: [contents sortBlock: aBlock].
! !

!SharedPriorityQueue methodsFor: 'access operations' stamp: 'rww 7/29/2000 22:56'!
subsetFrom: start to: stop
	^ self critical: [contents copyFrom: start to: stop]

! !

!SharedPriorityQueue methodsFor: 'protected operations' stamp: 'rww 7/29/2000 23:07'!
init: initSize

	contents := Heap new: initSize.
	accessProtect := Semaphore forMutualExclusion.
	readSync := Semaphore new.
	self sortBlock: [:a :b | a hash < b hash].
! !

!SharedPriorityQueue methodsFor: 'protected operations' stamp: 'rww 7/29/2000 22:47'!
next
	readSync wait.
	^ self nextNoWait.
! !

!SharedPriorityQueue methodsFor: 'protected operations' stamp: 'rww 7/29/2000 20:35'!
nextTimeoutMSecs: milliSeconds
	readSync waitTimeoutMSecs: milliSeconds.
	^self nextNoWait
! !

!SharedPriorityQueue methodsFor: 'protected operations' stamp: 'rww 7/29/2000 22:55'!
subset: limit contentsDo: aBlock
	| subset |
	subset := self subsetFrom: 1 to: limit.
	subset do: [:eachElement | aBlock value: eachElement].

! !

!SharedPriorityQueue methodsFor: 'printing' stamp: 'rww 7/27/2000 04:03'!
printOn: aStream

	aStream nextPutAll: 'priority queue => '.
	self size > 0
		ifTrue: [aStream nextPutAll: self size printString , ' events remaining'.
			self printQueueContentsOn: aStream]
		ifFalse: [aStream nextPutAll: 'empty'].! !

!SharedPriorityQueue methodsFor: 'printing' stamp: 'rww 7/27/2000 04:03'!
printQueueContentsOn: aStream 
	| printSize |
	(printSize := self size) > 10 
		ifTrue: [printSize := 10].
	self 
		subset: printSize 
		contentsDo: [:element | 
			aStream cr; tab; 
				nextPutAll: element printString].! !


!FixedSizeSharedPriorityQueue methodsFor: 'as yet unclassified' stamp: 'rww 7/29/2000 23:55'!
flush
	self critical: [contents size timesRepeat: [contents removeFirst. writeSync signal]].! !

!FixedSizeSharedPriorityQueue methodsFor: 'as yet unclassified' stamp: 'rww 7/29/2000 21:02'!
init: initSize
	super init: initSize.
	writeSync := Semaphore new.
	1 to: initSize do: [:each | writeSync signal].! !

!FixedSizeSharedPriorityQueue methodsFor: 'as yet unclassified' stamp: 'rww 7/29/2000 23:13'!
next
	| value |
	value := super next.
	value ifNotNil: [writeSync signal].
	^value
! !

!FixedSizeSharedPriorityQueue methodsFor: 'as yet unclassified' stamp: 'rww 7/29/2000 21:06'!
nextPut: aValue
	writeSync wait.
	^ super nextPut: aValue
! !

!FixedSizeSharedPriorityQueue methodsFor: 'as yet unclassified' stamp: 'rww 7/29/2000 21:05'!
nextPut: aValue timeoutMSecs: milliSeconds
	writeSync waitTimeoutMSecs: milliSeconds.
	^ super nextPut: aValue
! !

!FixedSizeSharedPriorityQueue methodsFor: 'as yet unclassified' stamp: 'rww 7/29/2000 23:15'!
nextTimeoutMSecs: milliSeconds
	| value |
	value := super nextTimeoutMSecs: milliSeconds.
	value ifNotNil: [writeSync signal].
	^value

! !


!SharedPriorityQueue class methodsFor: 'instance creation'!
new

	^self new: 10! !

!SharedPriorityQueue class methodsFor: 'instance creation'!
new: anInitSize 

	^(super new) init: anInitSize; yourself! !


!SharedQueue methodsFor: 'accessing' stamp: 'rww 1/13/2002 12:45'!
flush
	"Throw out all pending contents"
	accessProtect critical: [
		readPosition _ 1.
		writePosition _ 1.
		readPosition >= writePosition ifTrue: [readSynch initSignals].
		contentsArray 
			from: writePosition
			to: contentsArray size 
			put: nil].! !

!SharedQueue methodsFor: 'accessing' stamp: 'rww 8/26/2001 23:44'!
nextNoWait
	"Answer the object that was sent through the  
	
	receiver first and has not  
	
	yet been received by anyone. If no object has  
	
	been sent, return nil."
	^ self nextOrNil! !

!SharedQueue methodsFor: 'accessing' stamp: 'rww 1/13/2002 12:47'!
nextTimeoutMSecs: milliSeconds 
	"Answer the object that was sent through the  
	receiver first and has not  
	yet been received by anyone. If no object has 
	been sent, suspend the  
	requesting process until one is."

	| value |
	readSynch waitTimeoutMSecs: milliSeconds.
	accessProtect
		critical: 
			[readPosition = writePosition
				ifTrue: 
					[value := nil]
				ifFalse: 
					[value := contentsArray at: readPosition.
					contentsArray at: readPosition put: nil.
					readPosition := readPosition + 1]].
	^ value! !

!SharedQueue methodsFor: 'accessing' stamp: 'rww 1/13/2002 12:49'!
peek
	"Answer the object that was sent through the receiver first and has not 
	yet been received by anyone but do not remove it from the receiver. If 
	no object has been sent, suspend the requesting process until one is."

	| value |
	accessProtect
		critical: 
			[readPosition >= writePosition
				ifTrue: 
					[readPosition _ 1.
					writePosition _ 1.
					value _ nil]
				ifFalse: 
					[value _ contentsArray at: readPosition].
			readPosition >= writePosition ifTrue: [readSynch initSignals]].
	^value! !

!SharedQueue methodsFor: 'private' stamp: 'rww 1/13/2002 12:49'!
makeRoomAtEnd
	| contentsSize |
	readPosition = 1
		ifTrue: 
			[contentsArray _ contentsArray , (Array new: 10)]
		ifFalse: 
			[contentsSize _ writePosition - readPosition.

			contentsArray
				replaceFrom: 1
				to: contentsSize
				with: contentsArray
				startingAt: readPosition.
			readPosition _ 1.
			writePosition _ contentsSize + 1.
			contentsArray 
				from: writePosition
				to: contentsArray size 
				put: nil]! !


!Task methodsFor: 'accessing' stamp: 'rw 2/16/2002 15:06'!
priority

	^

process
		ifNil: [-1]
		ifNotNil: [process priority].
! !

!Task methodsFor: 'accessing' stamp: 'rw 2/16/2002 15:11'!
priority: aPriority

	(self isValidPriority: aPriority)
		ifFalse: [^self].

	process ifNotNil: 
		[process priority: aPriority].
! !

!Task methodsFor: 'accessing' stamp: 'slosh 11/19/2000 21:37'!
shouldRescheduleAction 

	^stopping 
		ifTrue: [false]
		ifFalse: [shouldRescheduleAction]! !

!Task methodsFor: 'accessing' stamp: 'rww 9/8/2000 12:35'!
shouldRescheduleAction: anEvaluableAction

	shouldRescheduleAction := anEvaluableAction! !

!Task methodsFor: 'accessing' stamp: 'rww 9/8/2000 12:34'!
taskAction

	^taskAction ! !

!Task methodsFor: 'accessing' stamp: 'rww 9/8/2000 12:36'!
taskAction: anEvaluableAction

	taskAction := anEvaluableAction! !

!Task methodsFor: 'scheduling' stamp: 'slosh 11/19/2000 21:32'!
isValidPriority: aPriority

	^ aPriority between: Processor systemBackgroundPriority and: Processor timingPriority 
! !

!Task methodsFor: 'scheduling' stamp: 'rw 2/16/2002 15:12'!
restart
	| myPriority |
	myPriority := self priority.
	self stop.
	self start.
	self priority: myPriority.


! !

!Task methodsFor: 'scheduling' stamp: 'rw 2/10/2002 17:02'!
schedule

	[self taskAction value.
	self shouldRescheduleAction value]
		whileTrue.
	stopSemaphore signal.
	process := nil.
! !

!Task methodsFor: 'scheduling' stamp: 'rw 2/16/2002 15:11'!
start

	process == nil ifFalse: [self error: 'Process has already been scheduled.'].
	stopping := false.
	stopSemaphore := Semaphore new.
	process := [self schedule] forkAt: Processor userInterruptPriority.
! !

!Task methodsFor: 'scheduling' stamp: 'rww 1/13/2002 22:40'!
stop

	process ifNil: [^self].
	stopping := true.
	stopSemaphore waitTimeoutMSecs: 1.
	process ifNotNil: 
		[process terminate.
		process := nil].! !


!Task class methodsFor: 'instance creation' stamp: 'rw 2/16/2002 18:59'!
taskAction: aTaskAction

	^self 
		taskAction: aTaskAction
		shouldRescheduleAction: true
! !

!Task class methodsFor: 'instance creation' stamp: 'rw 2/16/2002 15:09'!
taskAction: aTaskAction
shouldRescheduleAction: aBooleanAction

	^self new
		taskAction: aTaskAction;
		shouldRescheduleAction: aBooleanAction;
		yourself! !

