'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 14 July 2002 at 2:20:13 pm'!
TestCase subclass: #DispatchQueueTest
	instanceVariableNames: 'msgQueue gotMessage '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Async'!
TestCase subclass: #FixedSizeSharedPriorityQueueTest
	instanceVariableNames: 'queue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Collections-Queues'!
TestCase subclass: #SharedPriorityQueueTest
	instanceVariableNames: 'queue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Collections-Queues'!
TestCase subclass: #SharedQueueTest
	instanceVariableNames: 'queue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-SharedQueue'!
TestCase subclass: #TaskTestCase
	instanceVariableNames: 'task taskRunSem semTouched count countLimit '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Async'!

!DispatchQueueTest methodsFor: 'accessing'!
msgQueue
	"Answer the receiver's instance variable msgQueue."

	^msgQueue! !

!DispatchQueueTest methodsFor: 'asserting'!
gotMessage

	^ gotMessage! !

!DispatchQueueTest methodsFor: 'asserting' stamp: 'rww 1/13/2002 22:43'!
printMessage: aMessage 

"
	Transcript cr; show: self class name , '>>', self selector asString, '  ' , aMessage printString."
	gotMessage := true.
! !

!DispatchQueueTest methodsFor: 'asserting' stamp: 'rww 1/15/2002 02:25'!
receiveMessage: aMessage 

	gotMessage := true.
! !

!DispatchQueueTest methodsFor: 'running' stamp: 'rww 11/28/2000 12:51'!
setUp

	gotMessage := false.! !

!DispatchQueueTest methodsFor: 'running' stamp: 'rww 11/28/2000 12:55'!
tearDown

	self msgQueue ifNotNil: [self msgQueue suspend. msgQueue := nil.].! !

!DispatchQueueTest methodsFor: 'running' stamp: 'rww 1/15/2002 02:25'!
testBackgroundNoActionRemovalQueue
	| instCount |
	Smalltalk garbageCollect.
	instCount _ DispatchQueue instanceCount.
	msgQueue _ DispatchQueue new.
	self msgQueue background.
	self msgQueue priority: Processor userInterruptPriority.
	self msgQueue
		asyncSend: #receiveMessage:
		to: self
		with: 'hello world'.
	self assert: self gotMessage.
	self msgQueue close.
	msgQueue _ nil.
	Smalltalk garbageCollect.
	self assert: instCount - DispatchQueue instanceCount == 0! !

!DispatchQueueTest methodsFor: 'running' stamp: 'rww 1/15/2002 02:25'!
testBackgroundNoActionRemovalWithWeakArrayQueue
	| ref |
	msgQueue _ DispatchQueue new.
	ref _ WeakArray with: msgQueue.
	self msgQueue background.
	self msgQueue priority: Processor userInterruptPriority.
	self msgQueue
		asyncSend: #receiveMessage:
		to: self
		with: 'hello world'.
	self assert: self gotMessage.
	self msgQueue close.
	msgQueue _ nil.
	Smalltalk garbageCollect.
	self assert: ref first isNil! !

!DispatchQueueTest methodsFor: 'running' stamp: 'rww 1/15/2002 02:25'!
testBackgroundQueue
	msgQueue _ DispatchQueue new.
	gotMessage _ false.
	self msgQueue background.
	self msgQueue priority: Processor userInterruptPriority.
	self msgQueue
		asyncSend: #receiveMessage:
		to: self
		with: 'hello world'.
	self assert: self gotMessage.
	self msgQueue close.
	msgQueue _ nil! !

!DispatchQueueTest methodsFor: 'running' stamp: 'rw 2/16/2002 18:53'!
testForegroundQueue
	msgQueue _ DispatchQueue new.
	msgQueue foreground.
	gotMessage _ false.
	self msgQueue
		asyncSend: #receiveMessage:
		to: self
		with: 'hello world'.
	self msgQueue dispatch.
	self assert: self gotMessage.
	self msgQueue close.
	msgQueue _ nil! !

!DispatchQueueTest methodsFor: 'running' stamp: 'rww 1/18/2002 22:26'!
testLotsBackgroundQueue
	msgQueue _ DispatchQueue new.
	gotMessage _ false.
	self msgQueue background.
	self msgQueue priority: Processor userInterruptPriority.
	1 to: 100 do: [:e | self msgQueue
		asyncSend: #receiveMessage:
		to: self
		with: 'hello world: ', e printString].
	self assert: self gotMessage.
	self msgQueue close.
	msgQueue _ nil! !


!FixedSizeSharedPriorityQueueTest methodsFor: 'tests' stamp: 'rww 7/29/2000 23:11'!
testConcurrentPostCheckSharedQueue
	| sem1 sem2 |
	sem1 := Semaphore new.
	sem2 := Semaphore new.

	[1 to: 10 do: [:each | self queue nextPut: each]. sem1 signal] fork.
	[10 timesRepeat: [self queue next]. sem2 signal] fork. 
	sem1 wait.
	sem2 wait.

	[self queue size = 0]
		whileFalse: [(Delay forMilliseconds: 100) wait].

	self should: [self queue size = 0].

! !

!FixedSizeSharedPriorityQueueTest methodsFor: 'tests' stamp: 'rww 7/29/2000 23:11'!
testConcurrentPreCheckSharedQueue
	| sem1 sem2 |
	sem1 := Semaphore new.
	sem2 := Semaphore new.

	[1 to: 10 do: [:each | self queue nextPut: each]. sem1 signal] fork.
	[10 timesRepeat: [self queue next]. sem2 signal] fork. 

	[self queue size = 0]
		whileFalse: [(Delay forMilliseconds: 100) wait].

	sem1 wait.
	sem2 wait.

	self should: [self queue size = 0].

! !

!FixedSizeSharedPriorityQueueTest methodsFor: 'tests' stamp: 'rww 7/30/2000 05:26'!
testConcurrentPrintingSharedQueue
	| sem1 sem2 sem3 |
	sem1 := Semaphore new.
	sem2 := Semaphore new.
	sem3 := Semaphore new.

	[1 to: 10 do: [:each | (Delay forMilliseconds: 2) wait.
		self queue nextPut: each]. sem1 signal] fork.
	[5 timesRepeat: [(Delay forMilliseconds: 1) wait.
		self queue next]. sem2 signal] fork.
	[5 timesRepeat: [(Delay forMilliseconds: 1) wait.
		self queue next]. sem3 signal] fork.
	sem1 wait.
	sem2 wait.
	sem3 wait.

	self should: [self queue size = 0].! !

!FixedSizeSharedPriorityQueueTest methodsFor: 'tests' stamp: 'rww 7/29/2000 23:10'!
testConcurrentSharedQueue
	| sem1 sem2 |
	sem1 := Semaphore new.
	sem2 := Semaphore new.

	[1 to: 10 do: [:each | self queue nextPut: each]. sem1 signal] fork.
	[10 timesRepeat: [self queue next]. sem2 signal] fork. 
	sem1 wait.
	sem2 wait.

	self should: [self queue size = 0].

! !

!FixedSizeSharedPriorityQueueTest methodsFor: 'tests' stamp: 'rww 7/29/2000 23:54'!
testFlush
	| sem1 |
	sem1 := Semaphore new.

	[1 to: 10 do: [:each | self queue nextPut: each]. sem1 signal] fork.
	sem1 wait.
	self queue flush.
	self should: [self queue size = 0].

! !

!FixedSizeSharedPriorityQueueTest methodsFor: 'tests' stamp: 'rww 7/29/2000 23:10'!
testSharedQueue
	[1 to: 10 do: [:each | self queue nextPut: each]] fork.
	10 timesRepeat: [self queue next].
	self should: [self queue size = 0].! !

!FixedSizeSharedPriorityQueueTest methodsFor: 'fixtures' stamp: 'rww 7/29/2000 22:07'!
queue
	^ queue
! !

!FixedSizeSharedPriorityQueueTest methodsFor: 'fixtures' stamp: 'rww 7/29/2000 23:54'!
setUp
	queue := FixedSizeSharedPriorityQueue new: 20.
! !

!FixedSizeSharedPriorityQueueTest methodsFor: 'fixtures' stamp: 'rww 7/29/2000 22:07'!
tearDown
	queue := nil.
! !


!SharedPriorityQueueTest methodsFor: 'tests' stamp: 'rww 7/29/2000 22:34'!
testConcurrentPostCheckSharedQueue
	| sem1 sem2 |
	sem1 := Semaphore new.
	sem2 := Semaphore new.

	[1 to: 10 do: [:each | self queue nextPut: each]. sem1 signal] fork.
	[10 timesRepeat: [self queue next]. sem2 signal] fork. 
	sem1 wait.
	sem2 wait.

	[self queue size = 0]
		whileFalse: [(Delay forMilliseconds: 100) wait].

	self should: [self queue size = 0].

! !

!SharedPriorityQueueTest methodsFor: 'tests' stamp: 'rww 7/29/2000 22:34'!
testConcurrentPreCheckSharedQueue
	| sem1 sem2 |
	sem1 := Semaphore new.
	sem2 := Semaphore new.

	[1 to: 10 do: [:each | self queue nextPut: each]. sem1 signal] fork.
	[10 timesRepeat: [self queue next]. sem2 signal] fork. 

	[self queue size = 0]
		whileFalse: [(Delay forMilliseconds: 100) wait].

	sem1 wait.
	sem2 wait.

	self should: [self queue size = 0].

! !

!SharedPriorityQueueTest methodsFor: 'tests' stamp: 'rww 7/30/2000 05:25'!
testConcurrentPrintingSharedQueue
	| sem1 sem2 sem3 |
	sem1 := Semaphore new.
	sem2 := Semaphore new.
	sem3 := Semaphore new.

	[1 to: 10 do: [:each | (Delay forMilliseconds: 2) wait.
		self queue nextPut: each]. sem1 signal] fork.
	[5 timesRepeat: [(Delay forMilliseconds: 1) wait.
		self queue next]. sem2 signal] fork.
	[5 timesRepeat: [(Delay forMilliseconds: 1) wait.
		self queue next]. sem3 signal] fork.
	sem1 wait.
	sem2 wait.
	sem3 wait.

	self should: [self queue size = 0].! !

!SharedPriorityQueueTest methodsFor: 'tests' stamp: 'rww 7/29/2000 22:33'!
testConcurrentSharedQueue
	| sem1 sem2 |
	sem1 := Semaphore new.
	sem2 := Semaphore new.

	[1 to: 10 do: [:each | self queue nextPut: each]. sem1 signal] fork.
	[10 timesRepeat: [self queue next]. sem2 signal] fork. 
	sem1 wait.
	sem2 wait.

	self should: [self queue size = 0].

! !

!SharedPriorityQueueTest methodsFor: 'tests' stamp: 'rww 7/29/2000 23:53'!
testFlush
	| sem1 |
	sem1 := Semaphore new.

	[1 to: 10 do: [:each | self queue nextPut: each]. sem1 signal] fork.
	sem1 wait.
	self queue flush.
	self should: [self queue size = 0].

! !

!SharedPriorityQueueTest methodsFor: 'tests' stamp: 'rww 7/29/2000 23:09'!
testSharedQueue
	[1 to: 10 do: [:each | self queue nextPut: each]] fork.
	10 timesRepeat: [self queue next].
	self should: [self queue size = 0].! !

!SharedPriorityQueueTest methodsFor: 'fixtures' stamp: 'rww 7/29/2000 21:59'!
queue
	^ queue
! !

!SharedPriorityQueueTest methodsFor: 'fixtures' stamp: 'rww 7/29/2000 21:59'!
setUp
	queue := SharedPriorityQueue new.
! !

!SharedPriorityQueueTest methodsFor: 'fixtures' stamp: 'rww 7/29/2000 22:07'!
tearDown
	queue := nil.
! !


!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/13/2002 00:49'!
testBigSize

	1 to: 10000 do: [:each | self queue nextPut: each].
	self assert: self queue size = 10000.
	10000 timesRepeat: [self queue next].
	self assert: (self queue size = 0).! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/13/2002 01:20'!
testBlockingNext

	| start stop delay |
	delay := Delay forMilliseconds: 1.
	start := Time millisecondClockValue.
	[delay wait. self queue nextPut: start] fork.
	self assert: self queue next = start.
	stop := Time millisecondClockValue.
	self assert: (stop - start) >= 1.
! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/13/2002 01:21'!
testConcurrentSharedQueue
	| sem1 sem2 sem3 |
	sem1 := Semaphore new.
	sem2 := Semaphore new.
	sem3 := Semaphore new.
 
	[1 to: 10 do: 
		[:each | (Delay forMilliseconds: 2) wait.
		self queue nextPut: each]. 
	sem1 signal] fork.
	[5 timesRepeat: 
		[(Delay forMilliseconds: 1) wait. self queue next]. 
	sem2 signal] fork.
	[5 timesRepeat: 
		[(Delay forMilliseconds: 1) wait.  self queue next]. 
	sem3 signal] fork.
	sem1 wait.
	sem2 wait.
	sem3 wait.

	self should: [self queue size = 0].! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/13/2002 01:07'!
testContentsResetFromFlush

	self queue nextPut: 1.
	self assert: self queue peek = 1.
	self queue flush.
	self assert: ((self queue instVarAt: 1) select: [:e | e notNil]) isEmpty

! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/13/2002 01:14'!
testContentsResetFromFlushAllSuchThat

	1 to: 10 do: [:e | self queue nextPut: e].
	self queue flushAllSuchThat: [:e | e odd].
	self assert: ((self queue instVarAt: 1) select: [:e | e notNil]) size = 5

! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/13/2002 01:10'!
testContentsResetFromMakeRoomAtEnd

	self queue nextPut: 1.
	self queue nextPut: 1.
	self queue nextPut: 1.
	self queue nextPut: 1.
	self queue next.
	self queue next.
	self queue makeRoomAtEnd.
	self assert: ((self queue instVarAt: 1) at: 4) isNil.


! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/13/2002 01:07'!
testContentsResetFromPeek

	self queue nextPut: 1.
	self assert: self queue peek = 1.
	self assert: self queue next = 1.
	self queue peek.
	self assert: ((self queue instVarAt: 1) select: [:e | e notNil]) isEmpty

! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/12/2002 23:47'!
testFlush
	| sem1 |
	sem1 := Semaphore new.

	[1 to: 10 do: [:each | self queue nextPut: each]. sem1 signal] fork.
	sem1 wait.
	self queue flush.
	self should: [self queue size = 0].

! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/13/2002 01:22'!
testIsEmpty

	| delay |
	delay := Delay forMilliseconds: 1.
	[delay wait. self queue nextPut: 1] fork.
	self assert: self queue isEmpty.
	(Delay forMilliseconds: 2) wait.
	self deny: self queue isEmpty.
	self assert: self queue next = 1.

! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/13/2002 00:49'!
testLIFONextPut

	1 to: 10 do: [:each | self queue nextPut: each].
	self assert: self queue size = 10.
	self assert: (self queue next = 1).
	self assert: (self queue next = 2).
	self assert: (self queue next = 3).
	self assert: (self queue next = 4).
	self assert: (self queue next = 5).
	self assert: (self queue next = 6).
	self assert: (self queue next = 7).
	self assert: (self queue next = 8).
	self assert: (self queue next = 9).
	self assert: (self queue next = 10).
! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/13/2002 01:22'!
testNextOrNil

	| delay |
	delay := Delay forMilliseconds: 1.
	[delay wait. self queue nextPut: 1] fork.
	self assert: self queue nextOrNil = nil.
	self assert: self queue next =  1

! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/13/2002 01:22'!
testNextTimeout

	| delay |
	delay := Delay forMilliseconds: 2.
	[delay wait. self queue nextPut: 1] fork.
	self assert: (self queue nextTimeoutMSecs: 1) = nil.
	self assert: self queue next =  1

! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/13/2002 01:22'!
testPeek

	| delay |
	delay := Delay forMilliseconds: 1.
	[delay wait. self queue nextPut: 1] fork.
	self assert: self queue peek = nil.
	(Delay forMilliseconds: 2) wait.
	self assert: self queue peek = 1.
	self assert: self queue next = 1.

! !

!SharedQueueTest methodsFor: 'tests' stamp: 'rww 1/12/2002 23:52'!
testSize

	1 to: 10 do: [:each | self queue nextPut: each].
	self assert: self queue size = 10.
	10 timesRepeat: [self queue next].
	self assert: (self queue size = 0).! !

!SharedQueueTest methodsFor: 'fixtures' stamp: 'rww 1/12/2002 23:46'!
queue
	^ queue
! !

!SharedQueueTest methodsFor: 'fixtures' stamp: 'rww 1/12/2002 23:46'!
setUp
	queue := SharedQueue new.
! !

!SharedQueueTest methodsFor: 'fixtures' stamp: 'rww 1/12/2002 23:46'!
tearDown
	queue := nil.
! !


!TaskTestCase methodsFor: 'signalling' stamp: 'rww 9/8/2000 17:38'!
signalMultiTaskRun

	count := count + 1.
	(self count >= self countLimit)
		ifTrue: [self signalTaskRun].
	! !

!TaskTestCase methodsFor: 'signalling' stamp: 'rww 9/8/2000 16:41'!
signalTaskRun

	self semTouched: true.
	self taskRunSem signal.
	! !

!TaskTestCase methodsFor: 'signalling' stamp: 'rww 9/8/2000 17:30'!
waitForTaskRun

	self taskRunSem waitTimeoutMSecs: 500.
	^self semTouched
! !

!TaskTestCase methodsFor: 'accessing' stamp: 'rww 9/8/2000 17:38'!
count

	^count! !

!TaskTestCase methodsFor: 'accessing' stamp: 'rww 9/8/2000 17:38'!
countLimit

	^countLimit! !

!TaskTestCase methodsFor: 'accessing' stamp: 'rww 9/8/2000 17:39'!
countLimit: anInteger

	countLimit := anInteger! !

!TaskTestCase methodsFor: 'accessing' stamp: 'rww 9/8/2000 16:40'!
semTouched

	^semTouched
! !

!TaskTestCase methodsFor: 'accessing' stamp: 'rww 9/8/2000 16:41'!
semTouched: aBool

	semTouched := aBool
! !

!TaskTestCase methodsFor: 'accessing' stamp: 'rww 9/8/2000 16:27'!
task

	^task! !

!TaskTestCase methodsFor: 'accessing' stamp: 'rww 9/8/2000 16:37'!
task: aTask

	task := aTask.
! !

!TaskTestCase methodsFor: 'accessing' stamp: 'rww 9/8/2000 16:34'!
taskRunSem

	^ taskRunSem
 
! !

!TaskTestCase methodsFor: 'running' stamp: 'rww 9/8/2000 17:40'!
setUp

	taskRunSem := Semaphore new.
	count := 0.
	self semTouched: false.

! !

!TaskTestCase methodsFor: 'running' stamp: 'rww 9/8/2000 16:37'!
tearDown

	taskRunSem := nil.
! !

!TaskTestCase methodsFor: 'running' stamp: 'rw 2/16/2002 15:09'!
testMultipleTask

	| accum |
	accum := 6.
	self countLimit: 6.
	self task: (Task
		taskAction: [self signalMultiTaskRun]
		shouldRescheduleAction: [accum := accum - 1. accum >= 1]).
	task start. 	
	self assert: (self waitForTaskRun).
	task stop.
! !

!TaskTestCase methodsFor: 'running' stamp: 'rw 2/16/2002 15:09'!
testSingleTask

	self task: (Task
		taskAction: [self signalTaskRun]
		shouldRescheduleAction: false).
	self task start.
	self assert: (self waitForTaskRun).
	self task stop.
! !

