'From Squeak3.2gamma of 15 January 2002 [latest update: #4913] on 22 July 2002 at 3:50:53 am'!
Object subclass: #EventualMessageBroker
	instanceVariableNames: 'brokerId port connectionHandler secretary messageHandlers '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'References-Remote'!

!EventualMessageBroker commentStamp: 'rww 7/16/2002 04:17' prior: 0!
| broker1 broker2 |
broker1 := EventualMessageBroker startOnPort: 8888.
broker2 := EventualMessageBroker startOnPort: 9999.
broker1 inspect.
broker2 inspect.

[self handlerForRemoteBroker: 'localhost:9999'.
self stop.
]

[self sendOutgoingMessage: (MessageSend receiver: Object selector: #new).
self stop.
]

Smalltalk garbageCollect
EventualMessageBroker allInstances.
EventualMessageHandler allInstances.


Socket allInstances do: [:e | e closeAndDestroy].
!

Object subclass: #EventualMessageHandler
	instanceVariableNames: 'stream broker remoteBrokerId handlerTask objectMap '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'References-Remote'!
Object subclass: #RemoteObjectID
	instanceVariableNames: 'brokerID objectID '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'References-Remote'!
Object subclass: #RemoteObjectMap
	instanceVariableNames: 'imports exports questions answers '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'References-Remote'!

!EventualMessageBroker methodsFor: 'connection - client' stamp: 'rw 4/30/2002 07:30'!
sendFuture: aFuture to: aRemoteObjectId 

	| handler |
	handler := self handlerForRemoteBroker: aRemoteObjectId brokerID.
	handler sendResolvedFuture: aFuture.! !

!EventualMessageBroker methodsFor: 'connection - client' stamp: 'rw 4/30/2002 07:26'!
sendMessage: aMessage to: aRemoteObjectId 

	| handler |
	handler := self handlerForRemoteBroker: aRemoteObjectId brokerID.
	handler sendOutgoingMessage: aMessage.! !

!EventualMessageBroker methodsFor: 'connection - client sockets' stamp: 'rw 4/30/2002 07:21'!
addressAndPort: brokerIDString 
	"parses brokerIDString and get address and port"
	| colonPos serverAddress serverPort |
	colonPos _ brokerIDString findString: ':'.
	colonPos isZero
		ifTrue: [
			serverAddress _ brokerIDString.
			serverPort _ '9999']
		ifFalse: [
			serverAddress _ brokerIDString first: colonPos - 1.
			serverPort _ brokerIDString allButFirst: colonPos].
	^ {NetNameResolver addressForName: serverAddress. serverPort asInteger}! !

!EventualMessageBroker methodsFor: 'connection - client sockets' stamp: 'rw 4/30/2002 07:21'!
connectTo: brokerIDString 
	"open a socket to brokerIDString"
	| addressAndPort socket |
	addressAndPort _ self addressAndPort: brokerIDString.
	socket _ nil.
	10
		timesRepeat: [
			socket notNil
				ifTrue: [socket closeAndDestroy].
			socket _ Socket new.
			socket connectTo: addressAndPort first port: addressAndPort second.
			socket waitForConnectionUntil: Socket standardDeadline.
			socket isConnected
				ifTrue: [^ socket].
			(Delay forMilliseconds: 100) wait].
	self error: 'Can''t connect to: ', brokerIDString asString! !

!EventualMessageBroker methodsFor: 'connection - client sockets' stamp: 'rww 7/16/2002 02:35'!
deregisterHandler: handler

	self traceString: 'deregistering handler: ', handler remoteBrokerId asString.
	messageHandlers removeKey: handler remoteBrokerId ifAbsent: [].


! !

!EventualMessageBroker methodsFor: 'connection - client sockets' stamp: 'rww 7/16/2002 03:23'!
handleClientSocket: socket

	| handler |
	self traceString: 'handle incoming socket connection {', 
		socket localAddress asString, ', ', socket localPort asString, ', ',
		socket remoteAddress asString, ', ', socket remotePort asString, '}'.
	handler := EventualMessageHandler newOnBroker: self stream: (SocketStream on: socket).
	handler when: #handshaked send: #registerHandler: to: self with: handler.
	handler when: #stopped send: #deregisterHandler: to: self with: handler.
	handler start.
 	^handler! !

!EventualMessageBroker methodsFor: 'connection - client sockets' stamp: 'rww 7/15/2002 19:39'!
handlerForRemoteBroker: remoteBrokerId

	| socket |
	^messageHandlers 
		at: remoteBrokerId 
		ifAbsent: [
			socket := self connectTo: remoteBrokerId.
			self handleClientSocket: socket]
 ! !

!EventualMessageBroker methodsFor: 'connection - client sockets' stamp: 'rww 7/16/2002 02:35'!
registerHandler: handler

	self traceString: 'registering handler: ', handler remoteBrokerId asString.
	messageHandlers at: handler remoteBrokerId put: handler.


! !

!EventualMessageBroker methodsFor: 'connection - server' stamp: 'rw 5/4/2002 00:20'!
processFutureMessage: translatedMessage

	secretary sendMessage: translatedMessage ! !

!EventualMessageBroker methodsFor: 'private - running' stamp: 'rww 7/15/2002 19:39'!
startConnectionHandler
	connectionHandler _ ConnectionHandler
		onPort: port
		handler: [:socket | self handleClientSocket: socket]
		priority: Processor highIOPriority.
	connectionHandler start. ! !

!EventualMessageBroker methodsFor: 'private - running' stamp: 'rw 4/21/2002 10:20'!
startNetwork

	self startConnectionHandler.
 ! !

!EventualMessageBroker methodsFor: 'private - running' stamp: 'rw 4/21/2002 10:20'!
stopConnectionHandler
	connectionHandler isNil
		ifFalse: [""
			connectionHandler stop.
			connectionHandler _ nil] ! !

!EventualMessageBroker methodsFor: 'private - running' stamp: 'rw 4/21/2002 10:21'!
stopNetwork

	self stopConnectionHandler.
 ! !

!EventualMessageBroker methodsFor: 'initialization' stamp: 'rw 5/4/2002 11:46'!
initialize

	Socket initializeNetwork.
	secretary := DispatchSecretary dispatchBackground.
	messageHandlers := Dictionary new.




	" Old code from the RSTBroker "
	"
	initialize client side
	proxies _ WeakValueDictionary new. 
	proxiesMutex _ Semaphore forMutualExclusion.
	lastRemoteBrokers _ #().
	initialize server side
	exportedObjects _ WeakKeyManager new.
	exportedObjects
		onNewKey: [:object :key | 
			rememberer
				remember: object
				forSeconds: 6 * 60 * 60
				naming: brokerID].
	rememberer _ RSTRememberer new.
	"
! !

!EventualMessageBroker methodsFor: 'running' stamp: 'rw 5/4/2002 12:08'!
startOnPort: aPort
	"start this broker"
	port _ aPort.
	brokerId := NetNameResolver localAddressString , ':' , port asString.
	self startNetwork.
! !

!EventualMessageBroker methodsFor: 'running' stamp: 'rw 5/4/2002 12:00'!
stop

	self stopNetwork.
	messageHandlers do: [:e | e stop].! !

!EventualMessageBroker methodsFor: 'accessing' stamp: 'rww 7/15/2002 19:58'!
brokerId

	^brokerId! !

!EventualMessageBroker methodsFor: 'accessing' stamp: 'rw 4/30/2002 07:06'!
secretary

	^secretary! !


!EventualMessageBroker class methodsFor: 'running' stamp: 'rw 4/21/2002 10:19'!
new

	^super new initialize! !

!EventualMessageBroker class methodsFor: 'running' stamp: 'rw 4/21/2002 10:19'!
startOnPort: portInteger 
	"start the Broker with the default features"

	^ self new startOnPort: portInteger
! !


!EventualMessageHandler methodsFor: 'receiving' stamp: 'rww 7/15/2002 19:46'!
dispatchIncomingMessage: message

	| translatedMessage |
	self traceString: 'dispatching message...', message printString.
	translatedMessage := self translateIncomingMessage: message.
	broker processFutureMessage: translatedMessage.
! !

!EventualMessageHandler methodsFor: 'receiving' stamp: 'rww 7/15/2002 19:47'!
sendOutgoingMessage: message

	| translatedMessage encodedObject |
	translatedMessage := self translateOutgoingMessage: message.
	encodedObject := ReferenceStream streamedRepresentationOf: translatedMessage.
	self stream nextPutAll: encodedObject.
	self stream cr.
! !

!EventualMessageHandler methodsFor: 'receiving' stamp: 'rww 7/15/2002 19:46'!
sendResolvedFuture: aFuture

	| translatedMessage encodedObject |
	translatedMessage := self translateResolvedFuture: aFuture.
	encodedObject := ReferenceStream streamedRepresentationOf: translatedMessage.
	self stream nextPutAll: encodedObject.
	self stream cr.
! !

!EventualMessageHandler methodsFor: 'receiving' stamp: 'rww 7/15/2002 19:46'!
translateIncomingMessage: message

	^ self objectMap translateIncomingMessage: message
! !

!EventualMessageHandler methodsFor: 'receiving' stamp: 'rw 4/30/2002 07:31'!
translateOutgoingMessage: message

	^ self objectMap translateOutgoingMessage: message
! !

!EventualMessageHandler methodsFor: 'receiving' stamp: 'rw 4/30/2002 07:31'!
translateResolvedFuture: aFuture

	^ self objectMap translateResolvedFuture: aFuture
! !

!EventualMessageHandler methodsFor: 'accessing' stamp: 'rw 4/30/2002 07:27'!
broker

	^broker! !

!EventualMessageHandler methodsFor: 'accessing' stamp: 'rw 5/4/2002 11:47'!
objectMap

	^objectMap! !

!EventualMessageHandler methodsFor: 'accessing' stamp: 'rww 7/16/2002 02:51'!
remoteBrokerId

	^ remoteBrokerId! !

!EventualMessageHandler methodsFor: 'accessing' stamp: 'rww 7/15/2002 19:48'!
stream

	^ stream! !

!EventualMessageHandler methodsFor: 'control' stamp: 'rww 7/16/2002 04:02'!
dispatch

	| encodedObject object |
	[handlerTask isNil ifTrue: [^self].
	remoteBrokerId isNil 
		ifTrue:
			[remoteBrokerId := self stream upTo: Character cr.
			self triggerEvent: #handshaked]
		ifFalse:
			[encodedObject := self stream upTo: Character cr.
			object := ReferenceStream unStream: encodedObject.
			self dispatchIncomingMessage: object]]
				on: Error
				do: [:ex | 
					self traceString: 'stopping from exception: ', 
						ex messageText asString.
					self stop].

! !

!EventualMessageHandler methodsFor: 'control' stamp: 'rww 7/16/2002 03:36'!
handlerTask

	[remoteBrokerId := stream upTo: Character cr.
	self triggerEvent: #handshaked.
	[self dispatch] repeat]
		on: Error
		do: [:ex | self stop].
! !

!EventualMessageHandler methodsFor: 'control' stamp: 'rww 7/15/2002 19:59'!
initializeOnBroker: aBroker stream: aStream

	broker := aBroker.
	stream := aStream.
	objectMap := RemoteObjectMap new.
	stream nextPutAll: aBroker brokerId asString.
	stream cr.
! !

!EventualMessageHandler methodsFor: 'control' stamp: 'rww 7/16/2002 03:44'!
start

	handlerTask := Task taskAction: [self dispatch].
	handlerTask start.
! !

!EventualMessageHandler methodsFor: 'control' stamp: 'rww 7/16/2002 04:12'!
stop

	| theTask |
	handlerTask isNil 
		ifFalse: [
			theTask := handlerTask.
			[theTask stop] fork.
			handlerTask := nil].

	self stream isNil
		ifFalse: [
			self stream close.
			stream := nil].
	self triggerEvent: #stopped.! !


!EventualMessageHandler class methodsFor: 'as yet unclassified' stamp: 'rww 7/16/2002 02:56'!
newOnBroker: aBroker stream: aStream

	^self new 
		initializeOnBroker: aBroker stream: aStream;
		yourself
! !


!RemoteObjectID methodsFor: 'printing' stamp: 'rw 4/30/2002 07:34'!
printOn: aStream 
	aStream nextPutAll: objectID asString;
		 nextPut: $@;
		 nextPutAll: brokerID asString! !

!RemoteObjectID methodsFor: 'initialization' stamp: 'rw 4/30/2002 07:34'!
initializeBrokerID: brokerIDString objectID: objectIDString 
	brokerID _ brokerIDString.
	objectID _ objectIDString! !

!RemoteObjectID methodsFor: 'accessing' stamp: 'rw 4/30/2002 07:35'!
= anObject 
	self class == anObject class
		ifFalse: [^ false].
	^ brokerID = anObject brokerID
		and: [objectID = anObject objectID]! !

!RemoteObjectID methodsFor: 'accessing' stamp: 'rw 4/30/2002 07:33'!
brokerID
	^ brokerID! !

!RemoteObjectID methodsFor: 'accessing' stamp: 'rw 4/30/2002 07:35'!
hash
	^ brokerID hash bitXor: objectID hash! !

!RemoteObjectID methodsFor: 'accessing' stamp: 'rw 4/30/2002 07:33'!
objectID
	^ objectID! !


!RemoteObjectID class methodsFor: 'as yet unclassified' stamp: 'rw 4/30/2002 07:35'!
brokerID: brokerIDString objectID: objectIDString 
	"creates an instance with brokerIDString and objectIDString"
	^ self new initializeBrokerID: brokerIDString objectID: objectIDString! !

!RemoteObjectID class methodsFor: 'as yet unclassified' stamp: 'rw 4/30/2002 07:35'!
fromString: aString 
	"creates an instance from aString with the format objectID@brokerID"
	| atPos |
	atPos _ aString indexOf: $@.
	atPos isZero
		ifTrue: [self error: 'invalid format'].
	^ self
		brokerID: (aString allButFirst: atPos)
		objectID: (aString first: atPos - 1)! !


!RemoteObjectMap methodsFor: 'as yet unclassified' stamp: 'rw 5/4/2002 11:48'!
initialize

	exports := IdentityDictionary new.
	imports := IdentityDictionary new.
	questions := IdentityDictionary new.
	answers := IdentityDictionary new.
! !

!RemoteObjectMap methodsFor: 'as yet unclassified' stamp: 'rw 5/18/2002 05:42'!
translateIncomingMessage: message

	^message! !

!RemoteObjectMap methodsFor: 'as yet unclassified' stamp: 'rw 5/18/2002 05:42'!
translateOutgoingMessage: message

	^ message! !

!RemoteObjectMap methodsFor: 'as yet unclassified' stamp: 'rw 5/18/2002 05:42'!
translateResolvedFuture: aFuture

	^aFuture! !


!RemoteObjectMap class methodsFor: 'as yet unclassified' stamp: 'rw 5/4/2002 11:48'!
new

	^ super new initialize! !


!SocketStream methodsFor: 'stream in' stamp: 'rww 7/16/2002 03:08'!
upTo: delim 
	| string |
	(inStream includes: delim)
		ifTrue: ["Found the delimiter part way into buffer"
			string _ inStream upTo: delim.
			inStream next.
			^string].
	self isConnected not & self isDataAvailable not
		ifTrue: ["Never found it, and hit end of file"
			string _ inStream contents.
			self resetInStream.
			^string].
	"Never found it, but there's more..."
	self pvtGetDataUpTo: delim.
	^self upTo: delim! !

!SocketStream methodsFor: 'private' stamp: 'rww 7/15/2002 15:37'!
pvtGetData
	| data buffer bytesRead|
	buffer _ self bufferSized: 4000.
	[socket isConnected and: [socket dataAvailable not]]
		whileTrue: [ socket waitForDataUntil: 100].
	socket isConnected not
		ifTrue: [^self error: 'socket closed'].
	bytesRead _ socket receiveDataInto: buffer.
	data _ buffer
			copyFrom: 1
			to: bytesRead.
	inStream nextPutAll: data.
	self incInDataCountBy: bytesRead.
	^data! !

!SocketStream methodsFor: 'private' stamp: 'rww 7/16/2002 03:27'!
pvtGetDataUpTo: delim
	| data buffer bytesRead|
	buffer _ self bufferSized: 4000.
	[[self isConnected and: [self isDataAvailable not]]
		whileTrue: [ socket waitForDataUntil: (Socket deadlineSecs: 5)].
	self isConnected not
		ifTrue: [^self error: 'socket closed'].
	bytesRead _ socket receiveDataInto: buffer.
	data _ buffer
			copyFrom: 1
			to: bytesRead.
	inStream nextPutAll: data.
	self incInDataCountBy: bytesRead.
	inStream includes: delim] whileFalse.
	^data! !

!SocketStream methodsFor: 'testing' stamp: 'rww 7/16/2002 03:13'!
isConnected
	^self socket isConnected or: [self socket isOtherEndClosed not]! !

!SocketStream methodsFor: 'testing' stamp: 'rww 7/16/2002 03:01'!
isOtherEndClosed
	^self socket isOtherEndClosed! !


!Task methodsFor: 'scheduling' stamp: 'rww 7/16/2002 03:39'!
schedule

	[stopping not and: [self shouldRescheduleAction value]]
		whileTrue: [self taskAction value].
	stopSemaphore signal.
	process := nil.
! !

!Task methodsFor: 'scheduling' stamp: 'rww 7/16/2002 04:12'!
stop

	process ifNil: [^self].
	stopping := true.
	stopSemaphore waitTimeoutMSecs: 100.
	process ifNotNil: 
		[process terminate.
		process := nil].! !

SocketStream removeSelector: #isOtherEndConnected!
EventualMessageHandler class removeSelector: #startOnBroker:socket:!
EventualMessageHandler class removeSelector: #startOnBroker:stream:!
EventualMessageHandler removeSelector: #initializeOnBroker:socket:!
EventualMessageHandler removeSelector: #isDispatchNeeded!
EventualMessageHandler removeSelector: #remoteObjectId!

!EventualMessageHandler reorganize!
('receiving' dispatchIncomingMessage: sendOutgoingMessage: sendResolvedFuture: translateIncomingMessage: translateOutgoingMessage: translateResolvedFuture:)
('accessing' broker objectMap remoteBrokerId stream)
('control' dispatch handlerTask initializeOnBroker:stream: start stop)
!

EventualMessageBroker removeSelector: #handleClientStream:!
