'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 14 July 2002 at 2:18:53 pm'!
Array variableSubclass: #WeakActionSequence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!Object methodsFor: 'converting' stamp: 'rw 4/27/2002 07:48'!
asActionSequence

	^WeakActionSequence with: self! !

!Object methodsFor: 'events' stamp: 'rw 4/27/2002 07:20'!
when: anEventSelector
send: aMessageSelector
to: anObject

    self
        when: anEventSelector
        evaluate: (WeakMessageSend
            receiver: anObject
            selector: aMessageSelector)! !

!Object methodsFor: 'events' stamp: 'rw 4/27/2002 07:21'!
when: anEventSelector
send: aMessageSelector
to: anObject
with: anArg

    self
        when: anEventSelector
        evaluate: (WeakMessageSend
            receiver: anObject
            selector: aMessageSelector
		arguments: (Array with: anArg))! !

!Object methodsFor: 'events' stamp: 'rw 4/27/2002 07:21'!
when: anEventSelector
send: aMessageSelector
to: anObject
withArguments: anArgArray

    self
        when: anEventSelector
        evaluate: (WeakMessageSend
            receiver: anObject
            selector: aMessageSelector
		arguments: anArgArray)! !

!Object methodsFor: 'events-accessing' stamp: 'rw 4/27/2002 07:50'!
actionForEvent: anEventSelector
    "Answer the action to be evaluated when <anEventSelector> has been triggered."

	| actions |
	actions := self actionMap
		at: anEventSelector asSymbol
		ifAbsent: [nil].
	actions ifNil: [^nil].
	actions isReceiverOrAnyArgumentGarbage
		ifTrue: [actions := actions asMinimalRepresentation].
	^ actions! !

!Object methodsFor: 'events-accessing' stamp: 'rw 4/27/2002 07:51'!
actionForEvent: anEventSelector
ifAbsent: anExceptionBlock
    "Answer the action to be evaluated when <anEventSelector> has been triggered."

	| actions |
	actions := self actionMap
		at: anEventSelector asSymbol
		ifAbsent: [nil].
	actions ifNil: [^anExceptionBlock value].
	actions isReceiverOrAnyArgumentGarbage
		ifTrue: [actions := actions asMinimalRepresentation].
	^ actions
! !

!Object methodsFor: 'events-accessing' stamp: 'rw 4/27/2002 08:35'!
actionSequenceForEvent: anEventSelector

    ^(self actionMap
        at: anEventSelector asSymbol
        ifAbsent: [^WeakActionSequence new])
            asActionSequence! !


!EventTestCase methodsFor: 'running-broadcast query' stamp: 'rw 4/27/2002 09:12'!
testMultipleValueSuppliersEventHasArgumentsWithGC

	eventSource
		when: #needsValue:
		send: #getFalse:
		to: self
		with: Object new.
	eventSource
		when: #needsValue:
		send: #getTrue:
		to: self
		with: Object new.
	Smalltalk garbageCollectMost.
	succeeded := eventSource triggerEvent: #needsValue: with: 'kolme'.
	self should: [succeeded = nil]
! !


!MessageSend methodsFor: 'evaluating' stamp: 'reThink 2/18/2001 16:51'!
valueWithArguments: anArray

	^ receiver 
		perform: selector 
		withArguments: (self collectArguments: anArray)! !


!WeakActionSequence methodsFor: 'converting' stamp: 'rw 4/27/2002 07:44'!
asActionSequence

	^self! !

!WeakActionSequence methodsFor: 'converting' stamp: 'rw 4/27/2002 08:36'!
asMinimalRepresentation

	| valid |
	valid := self select: [:e | e isReceiverOrAnyArgumentGarbage not].
	valid size = 0
		ifTrue: [^nil].
	valid size = 1
		ifTrue: [^self first].
	^valid! !

!WeakActionSequence methodsFor: 'evaluating' stamp: 'rw 4/27/2002 07:45'!
value
    "Answer the result of evaluating the elements of the receiver."

    | answer |
    self do:
        [:each |
		each isReceiverOrAnyArgumentGarbage 
			ifFalse: [answer := each value]].
    ^answer! !

!WeakActionSequence methodsFor: 'evaluating' stamp: 'rw 4/27/2002 07:45'!
valueWithArguments: anArray

    | answer |
    self do:
        [:each |
        	each isReceiverOrAnyArgumentGarbage 
			ifFalse: [answer := each valueWithArguments: anArray]].
    ^answer
! !

!WeakActionSequence methodsFor: 'testing' stamp: 'rw 4/27/2002 07:47'!
isReceiverOrAnyArgumentGarbage 

	^ self
		inject: false
		into: [:truth :element | truth or: [element isReceiverOrAnyArgumentGarbage]]! !

!WeakActionSequence methodsFor: 'printing' stamp: 'rw 4/27/2002 07:46'!
printOn: aStream

	self size < 2 ifTrue: [^super printOn: aStream].
	aStream nextPutAll: '#('.
	self
		do: [:each | each printOn: aStream]
		separatedBy: [aStream cr].
	aStream nextPut: $)! !


!WeakMessageSend methodsFor: 'evaluating' stamp: 'rw 4/27/2002 07:41'!
valueWithArguments: anArray
	self ensureReceiverAndArguments.
	^ self receiver 
		perform: selector 
		withArguments: (self collectArguments: anArray)! !

!WeakMessageSend methodsFor: 'private' stamp: 'rw 4/27/2002 07:33'!
isAnyArgumentGarbage
	"Make sure that my arguments haven't gone away"
	arguments ifNotNil: [
		arguments with: shouldBeNil do: [ :arg :flag |
			(flag not and: [arg isNil])
				ifTrue: [^true]
		]
	].
	^false
! !

!WeakMessageSend methodsFor: 'private' stamp: 'rw 4/27/2002 07:31'!
isReceiverGarbage
	"Make sure that my receiver hasn't gone away"
	^self receiver isNil
! !

!WeakMessageSend methodsFor: 'private' stamp: 'rw 4/27/2002 07:34'!
isReceiverOrAnyArgumentGarbage
	"Make sure that my receiver hasn't gone away"
	^self isReceiverGarbage 
		or: [self isAnyArgumentGarbage]
! !

